## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of Align2


cd D:\documents\audio\align2\files\octave\;
wavfile1 ='D:\documents\audio\roomEQ\mesures-sur-sites\igor130613\19.wav';
wavfilename1 = "19";
wavfilepath1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130613\';
fdevice = '-S1200,220';





##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	
	[ir1,fs,bps] = wavread([wavfile1]);

##############################################################################	

	ir1 = [ zeros(1,9600) ir1(:)' ];
	ir1 = [ ir1(:)' zeros(1,9600) ];  

	[irm1,ic1] = max(abs(ir1));	

	# Normalize to +1
	ir1 = sign(max(real(ir1(:)))/max(real(-ir1(:)))-1)*ir1/irm1;	
	
	# Report the impulse centers
	disp(sprintf("IR1 impulse center: %d, max: %f",ic1, irm1));
	
	# Resampling factor
	rf = 40;
	
	# Resampling filter length, cutoff frequency and attenuation
	rfl = 16383;
	rcf = 0.95;
	rat = 160;
	
	# Upsample from about -10 to +50 ms
	irp = 1*fs/100;
	ira = 5*fs/100;
	
	# Creates the oversampled impulse responses
	ir1os = rf * iupsample(ir1([ic1-irp:ic1+ira]),rf,rfl,rcf,rat);

	#pour mettre le pic IR et ETC à 0
	rms1 = max(ir1os);
	ir1os = ir1os(:)/rms1;
	
	# Report the stage
	disp("Time response, full range...");
	fflush(stdout);
	
	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");
	
	# Plot the oversampled impulse responses 1
	subplot(1,3,1);
	plot(1000 * ((([0:length(ir1os)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir1os,["3;" ";"],"LineWidth",DLW);
	axis([-10, 50, -1, 1]);
	grid("on");
	xlabel("Time (ms)");
	ylabel("Amplitude (normalized)");	
	title("Impulse response");
	
	# Creates the step response
	ir1step = fftconv(ir1os,ones(1,length(ir1os)))/rf;
	ir1sm = max(abs(ir1step))
	irsm = max(ir1sm)
	ir1step = ir1step/irsm;
	
	# Plot the step response
	subplot(1,3,2);	
	plot(1000 * ((([0:length(ir1step)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir1step,["3;" wavfilename1 ";"],"LineWidth",DLW);
	axis([-10, 50, -1, 1]);
	grid("on");
	title("Step response");
		
	# Save the axis range
	g1ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = min(g1ax(3));
	gax(4) = max(g1ax(4));
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(1) = -10;
	gax(2) = 50;
	gax(3) = -1;
	gax(4) = 1;
	
	# Computes the window, 5 ms
	wind = [ones(1,fs/100) ones(1,floor(fs/200)) (blackman(floor(fs/100))(floor(fs/200+1):floor(fs/100)))' zeros(1,8192 - (fs/100 + floor(fs/100)))]';
	# Extract the 5ms windowed impulse responses

	ir1wp = ir1([ic1:ic1+8191]);	
	#irphase	= 180 * unwrap(angle(ir1wp))/pi;
	irphase	= 180 * unwrap(cphase(ir1wp))/pi;	
	irphasem = mean(irphase(100:1000));
	irphase = irphase - irphasem;	


	ir1w = (ir1([ic1-fs/100:ic1+(8192 - (fs/100 + 1))]))' .* wind;

	# Rotate the impulse response and transform to the frequency domain
	ir1w = fft([ir1w(fs/100+1:length(ir1w))' ir1w(1:fs/100)']);
	ix1m = max(ir1w);
	ir1w = ir1w/ix1m;
		
	irphase	= 180 * unwrap(angle(ir1wp([2:length(ir1w)/2])))/pi;
	irphasem = mean(irphase(100:1000));
	irphase = irphase - irphasem;	
	
	# Plot the phase response 1
	subplot(1,3,3);
	semilogx(0.001 * fs * [1:(length(ir1w)/2)-1] / length(ir1w),irphase,["3;" ";"],"LineWidth",DLW);
	axis([0.2, 20, -720, 720]);
	grid("on");
	safetics("x",[0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,13,16,20]);
	safetics("y",-720:90:720);
	title("Phase 5 ms gating");
	
	# Compute the index limits
	ixl = floor(200 * length(ir1w) / fs);
	ixu = ceil(40000 * length(ir1w) / fs);
	ixg = ixl:ixu;

	# Print to the output file
	print([ wavfilepath1 wavfilename1 "-ir" fext ],fdevice);
		
	# Remove variables no longer used
	clear ir1step ir2step;
	
	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);