## Copyright (C) 2012 Jean-Luc Ohl
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of Align2


cd D:\documents\audio\align2\files\octave\;
wavfile1 ='D:\documents\audio\align2\measurements\testAP6\convolution\testAP6-APMC-R.wav';
wavfilename1 = "testAP6-APMC-R";
wavfilepath1 = 'D:\documents\audio\align2\measurements\testAP6\convolution\';
wavfile2 = 'D:\documents\audio\align2\measurements\testAP6\convolution\testAP6-SDLC-R1.wav';
wavfilename2 = "testAP6-SDLC-R1.wav";
wavfilepath2 = 'D:\documents\audio\align2\measurements\testAP6\convolution\';
fdevice = '-S1200,220';






##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	# Set the default line width
	DLW = 1.5;
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	# Enable contour display	when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	

	[wav1,fs,bps] = wavread([wavfile1]);
	[wav2,fs,bps] = wavread([wavfile2]);	
	
##############################################################################	
	disp("wavfile1");

	wav1 = [zeros(1,480) wav1(:)' zeros(1,65536)];	
	[irm,ic] = max(abs(wav1));	
	wav1 = wav1([(ic - 480):(ic + (65536 - (480 + 1)))]);
	wav1 = wav1/max(abs(wav1(:)));	
	wav1 = fftshift(wav1);
	wav1_fft = ssev(wav1,fs,0.1,1);	
	
###################	
	disp("wavfile2");

	wav2 = [zeros(1,480) wav2(:)' zeros(1,65536)];	
	[irm,ic] = max(abs(wav2));	
	wav2 = wav2([(ic - 480):(ic + (65536 - (480 + 1)))]);
	wav2 = wav2/max(abs(wav2(:)));	
	wav2 = fftshift(wav2);
	wav2_fft = ssev(wav2,fs,0.1,1);		
		
###################		
	disp("convolution");
	
	irconv = fftconv(wav1,wav2);
	irconv = irconv/max(abs(irconv));

	irconv = [zeros(1,480) irconv(:)' zeros(1,65536)];		
	conv = reshape(irconv,columns(irconv),1);
	conv_fft = ssev(conv,fs,0.1,1);
	conv_ = fftshift(conv);	
	[irm,ic] = max(abs(conv_));	
	wavwrite(conv_,fs,32,[wavfilepath1 wavfilename1 "x" wavfilename2]);	
	conv_ = conv_([(ic - 480):(ic + (6144 - (480 + 1)))]);
	wavwrite(conv_,fs,32,[wavfilepath1 wavfilename1 "-6144x" wavfilename2]);
	conv = wavread([wavfilepath1 wavfilename1 "-6144x" wavfilename2]);	
	conv = ssev(conv,fs,0.1,1);

	
###################

	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,13,16,20]);
	title("Original files");
	
	subplot(1,2,2);
	hold("on");
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,13,16,20]);
	title("Convolution");	

	# Plot the magnitude response 1
	ixg= [1:columns(wav1_fft)];
	subplot(1,2,1);
	semilogx(0.001*(ixg)*fs/(2*columns(wav1_fft)), 20*log10(wav1_fft(ixg)),["3;" wavfilename1 ";"],"LineWidth",DLW);
		
	# Plot the magnitude response 2
	ixg= [1:columns(wav2_fft)];
	subplot(1,2,1);
	semilogx(0.001*(ixg)*fs/(2*columns(wav2_fft)), 20*log10(wav2_fft(ixg)),["1;" wavfilename2 ";"],"LineWidth",DLW);
		
	# Plot the magnitude response 3
	ixg= [1:columns(wav1_fft)];
	subplot(1,2,2);
	semilogx(0.001*(ixg)*fs/(2*columns(wav1_fft)), 20*log10(wav1_fft(ixg)),["3;" wavfilename1 ";"],"LineWidth",DLW);

	# Plot the magnitude response 4
	ixg= [1:columns(conv_fft)];
	subplot(1,2,2);
	semilogx(0.001*(ixg)*fs/(2*columns(conv_fft)), 20*log10(conv_fft(ixg)),["2;" "convolution" ";"],"LineWidth",DLW);

	# Plot the magnitude response 5
	ixg= [1:columns(conv)];
	subplot(1,2,2);
	semilogx(0.001*(ixg)*fs/(2*columns(conv)), 20*log10(conv(ixg)),["1;" "convolution 6144taps" ";"],"LineWidth",DLW);
	
	# Save the axis range
	g1ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -18;
	gax(4) = 30;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -18;
	gax(4) = 30;	
		
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));	
		
	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	subplot(1,2,2);
	hold("off");
		
	# Print to the output file
	print([wavfilepath1 wavfilename1 "-convolved" '.png'],fdevice);	

		
##############################################################################		
	
	# Report the stage
	disp("Completed.");
	fflush(stdout);