## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## script for Align2, by Jean-Luc Ohl
# psychoacoustic curve smoothtype = -2 for ERB, -1 for Bark, 0.33 for 1/3 octave, 0.15 for 1/6 octave,...

cd D:\documents\audio\align2\files\octave\;
ir1 ='D:\documents\audio\align2\measurements\test24\L4.wav';
irname1 = "L4.wav";
ir2 ='D:\documents\audio\align2\measurements\test24\R4.wav';
irname2 = "R4.wav";
fprefix = "test24";
fpath = 'D:\documents\audio\align2\measurements\test24\';
fdevice = '-S1200,220';
limits = 1;
HFW = 3;
LFW = 100;
WEG = 1;
smoothtype = -2;
SE = 10;
mic = load('D:\documents\audio\align2\files\mic\kt-vert1.txt');




	
##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	[ir1,fs,bps] = wavread([ir1]);
	[ir2,fs,bps] = wavread([ir2]);

	ir1 = [ zeros(1,65536) ir1(:)' ];
	ir1 = [ ir1(:)' zeros(1,65536) ];
	[irm1,ic1] = max(abs(ir1));		
	rms1 = max(abs(ir1));	
	
	ir2 = [ zeros(1,65536) ir2(:)' ];
	ir2 = [ ir2(:)' zeros(1,65536) ];	
	[irm2,ic2] = max(abs(ir2));
	rms2 = max(abs(ir2));	
	
	# Report infos
	disp(sprintf("Frequency : %d,",fs));
	disp(sprintf("IR1 impulse center : %d, max: %f, RMS: %f",ic1, irm1, rms1));
	disp(sprintf("IR2 impulse center : %d, max: %f, RMS: %f",ic2, irm2, rms2));
	fflush(stdout);	
	
	
##############################################################################	
	# Report the stage
	disp("Mic correction...");
	fflush(stdout);	

	disp(mic)
	xp = mic(:,1);
	yp = -mic(:,2);
	ixg = [1:fs/2];
	mic_interp = interp1(xp, yp, ixg, "pchip");
	mic_interp = reshape(mic_interp,columns(mic_interp),1);
	mic_log = exp(mic_interp*log(10)/20);
	mic_log1 = [mic_log(:); zeros(fs/2,1)];		
	mic_ir = ifft(mic_log1);
	mic_ir = fftshift(mic_ir);
	wavwrite(mic_ir,fs,32,[fpath "mic_ir.wav"]);	
	mic_wav = wavread([fpath "mic_ir.wav"]);	

	ir1 = [zeros(1,480) ir1(:)' zeros(1,65536)];
	[irm,ic] = max(abs(ir1));	
	ir1f = ir1([(ic1 - 480):(ic1 + (65536 - (480 + 1)))]);
	ir1f = fftshift(ir1f);
	ir1_fft = ssev(ir1,fs,0.1,1);	
	
	ir2 = [zeros(1,480) ir2(:)' zeros(1,65536)];	
	[irm,ic] = max(abs(ir2));	
	ir2f = ir2([(ic2 - 480):(ic2 + (65536 - (480 + 1)))]);
	ir2f = fftshift(ir2f);
	ir2_fft = ssev(ir2f,fs,0.1,1);	
	
	disp("IR-mic convolution");

	irconv1 = fftconv(ir1f,mic_ir);
	irconv1b = [zeros(1,480) irconv1(:)' zeros(1,65536)];	
	conv1 = reshape(irconv1b,columns(irconv1b),1);
	[irm,ic1] = max(abs(conv1));	
	conv1_ = fftshift(conv1);	
	wavwrite(conv1_,fs,32,[fpath "irconv1.wav"]);
	convwav1 = wavread([fpath "irconv1.wav"]);	
	convwav1 = ssev(convwav1,fs,0.1,1);
	
	irconv2 = fftconv(ir2f,mic_ir);
	irconv2b = [zeros(1,480) irconv2(:)' zeros(1,65536)];	
	conv2 = reshape(irconv2b,columns(irconv2b),1);
	[irm,ic2] = max(abs(conv2));	
	conv2_ = fftshift(conv2);	
	wavwrite(conv2_,fs,32,[fpath "irconv2.wav"]);
	convwav2 = wavread([fpath "irconv2.wav"]);	
	convwav2 = ssev(convwav2,fs,0.1,1);
	
	# Normalize each to +1
	ir1n = sign(max(real(conv1))/max(real(-conv1))-1)*conv1/rms1;	
	ir2n = sign(max(real(conv2))/max(real(-conv2))-1)*conv2/rms2;
	
	# Normalize highest of both	to +1, keep delta
	rms = max(rms1(:), rms2(:))	
	ir1nn = sign(max(real(conv1))/max(real(-conv1))-1)*conv1/rms;	
	ir2nn = sign(max(real(conv2))/max(real(-conv2))-1)*conv2/rms;
	
##############################################################################

# Report the stage
	disp("Mic correction and gating");
	fflush(stdout);
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	grid("on");	
	axis([0.02, 20,-12,12]);
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	safetics("y",[-12,-9,-6,-3,0,3,6,9,12]);	
	title("Microphone correction");	

	# Plot the mic magnitude response 1
	ixg= [1:rows(mic_log)];	
	subplot(1,2,1);
	semilogx(0.001*(ixg)*fs/(2*rows(mic_log)), 20*log10(mic_log(ixg)),["3;" "mic correction" ";"],"LineWidth",DLW);	

	subplot(1,2,1);
	hold("off");	
	
	subplot(1,2,2);
	hold("on");
	grid("on");	
	axis([0.02, 20, 0.2, 500]);
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	safetics("y",[0.2,0.5,1,2,5,10,20,50,100,200,500]);	
	title("Psychoacoustic gating, ms / KHz");	
	
	# Set the frequency dependent windowing basic parameters
	np = 31768;
	# Creates the windows array
	wa = linspace(HFW,LFW,np);	
	# Computes the gabor limit
	gl = 1000 ./ (linspace(0.1,500,np));
			
	# Plot the frequency dependent gating with frequency on x axys
	hold("on");
	subplot(1,2,2);
	loglog(12*gl/1000,linspace(0.1,500,np),";12 periods;","color",[0.85,0.85,0.85],"LineWidth",DLW);
	loglog(6*gl/1000,linspace(0.1,500,np),";6 periods;","color",[0.7,0.7,0.7],"LineWidth",DLW);
	loglog(3*gl/1000,linspace(0.1,500,np),";3 periods;","color",[0.55,0.55,0.55],"LineWidth",DLW);
	loglog(fslprefilt(20,LFW,20000,HFW,WEG,np)/1000,wa,sprintf(";Hamming gating at -6dB, %.0f-%.0fms, WE=%.1f;",HFW, LFW, WEG),"color",hsv2rgb([10, 1, 1]),"LineWidth",DLW);
	
	subplot(1,2,2);
	hold("off");

	# Print to the output file
	print([ fpath fprefix "-Mic-and-psychoacoustic-gating" fext ],fdevice);
					
##############################################################################	
	# Report the stage
	disp("Impulse response upsampling...");
	fflush(stdout);

	# Resampling factor
	rf = 40;
	# Resampling filter length, cutoff frequency and attenuation
	rfl = 16383;
	rcf = 0.95;
	rat = 160;
	# Upsample from about -10 to +20 ms
	irp = fs/100;
	ira = 2*fs/100;
	
	# Creates the oversampled impulse responses
	ir1os = rf * iupsample(ir1n([ic1-irp:ic1+ira]),rf,rfl,rcf,rat);
	ir2os = rf * iupsample(ir2n([ic2-irp:ic2+ira]),rf,rfl,rcf,rat);
	
	##############################################################################		
	# Report the stage
	disp("Time response, full range...");
	fflush(stdout);

	# normalize impulse response
	ir1os = ir1os/max(abs(ir1os));
	ir2os = ir2os/max(abs(ir2os));

	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");
	
	# Plot the oversampled impulse responses 1
	subplot(1,2,1);
	plot(1000 * ((([0:length(ir1os)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir1os,["3;" irname1 ";"],"LineWidth",DLW);
	axis([-1, 10]);
	grid("on");
	title("Impulse response, amplitude (normalized) / time (ms)");
		
	# Plot the oversampled impulse responses 2
	subplot(1,2,2);
	plot(1000 * ((([0:length(ir2os)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir2os,["1;" irname2 ";"],"LineWidth",DLW);
	axis([-1, 10]);
	grid("on");
	
	# Computes the uniform axis range
	gax = axis();
	gax(1) = -1;
	gax(2) = 10;
	gax(3) = -1;
	gax(4) = 1;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("x",gax(1):1:gax(2));
	safetics("y",gax(3):0.5:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("x",gax(1):1:gax(2));
	safetics("y",gax(3):0.5:gax(4));
	
	# Print to the output file
	print([ fpath fprefix "-Impulse-Response" fext ],fdevice);
		
##############################################################################	
	# Report the stage
	disp("Step response...");
	fflush(stdout);
	
	# Creates the step response
	ir1step = fftconv(ir1os,ones(1,length(ir1os)))/rf;
	ir1step = ir1step/max(abs(ir1step));	
	
	ir2step = fftconv(ir2os,ones(1,length(ir2os)))/rf;
	ir2step = ir2step/max(abs(ir2step));	
		
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Plot the step response 1
	subplot(1,2,1);	
	plot(1000 * ((([0:length(ir1step)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir1step,["3;" irname1 ";"],"LineWidth",DLW);
	grid("on");
	#ylabel("Amplitude (normalized)");	
	title("Step response, amplitude (normalized), time (ms)");
		
	# Plot the step response 2
	subplot(1,2,2);
	plot(1000 * ((([0:length(ir2step)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir2step,["1;" irname2 ";"],"LineWidth",DLW);
	grid("on");
	
	# Computes the uniform axis range
	gax = axis();
	gax(1) = -4;
	gax(2) = 20;
	gax(3) = -1;
	gax(4) = 1;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	safetics("y",gax(3):0.5:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	safetics("y",gax(3):0.5:gax(4));

	# Print to the output file
	print([ fpath fprefix"-Step-Response" fext ],fdevice);
		
	# Remove variables no longer used
	clear ir1step ir2step;
	
	# Computes the analytical signal
	ir1osh = abs((ir1os));
	ir2osh = abs((ir2os));
				
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Plot the energy-time curve 1
	subplot(1,2,1);
	plot(1000*((([0:length(ir1osh)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),20 * log10(ir1osh),["3;" irname1 ";"],"LineWidth",DLW);
	axis([-2, 20, 0, -40]);
	grid("on");
	title("Energy-time curve");
		
	# Plot the energy-time curve 2
	subplot(1,2,2);
	plot(1000*((([0:length(ir2osh)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),20 * log10(ir2osh),["1;" irname2 ";"],"LineWidth",DLW);
	axis([-2, 20, 0, -40]);
	grid("on");
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = -40;
	gax(4) = 0;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	subplot(1,2,2);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	
	# Print to the output file
	print([ fpath fprefix"-Energy-Time-Curve" fext ],fdevice);

	# Remove variables no longer used
	#clear ir1os ir2os ir1osh ir2osh rfl rcf rat;
	
##############################################################################	
	# Report the stage
	disp("Time response, 1-8 kHz brickwall...");
	fflush(stdout);
	
	# Create the 1-8 kHz brickwall filter
	fltlen = 8192;
	fltatt = 160;
	flt = bandpassfir(fltlen,1000/(fs/2),8000/(fs/2) ) .* chebwin(fltlen,fltatt)';
	fltdelay = (1 + length(flt)) / 2;
	
	# Creates the 1 kHz brickwall filtered impulse responses about -20 to +50 ms
	ir1bw = fftconv(flt,ir1n([ic1-fs/50:ic1+fs/20]));
	ir1bw = ir1bw(:)/max(abs(ir1bw));
	ir1bwh = abs((ir1bw));
	
	ir2bw = fftconv(flt,ir2n([ic2-fs/50:ic2+fs/20]));
	ir2bw = ir2bw(:)/max(abs(ir2bw));
	ir2bwh = abs((ir2bw));	
		
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Plot the energy-time curve 1
	subplot(1,2,1);
	plot(1000*((([0:length(ir1bwh)-1])/fs)-((fltdelay + fs/50)/fs)),20 * log10(ir1bwh),["3;" irname1 ";"],"LineWidth",DLW);
	axis([-2, 20, round(-30 + 20 * log10(max(ir1bwh))), round(3 + 20 * log10(max(ir1bwh)))]);
	grid("on");
	title("ETC filtered 1-8 kHz");		
	
	# Plot the energy-time curve 2
	subplot(1,2,2);
	plot(1000*((([0:length(ir2bwh)-1])/fs)-((fltdelay + fs/50)/fs)),20 * log10(ir2bwh),["1;" irname2 ";"],"LineWidth",DLW);
	axis([-2, 20, round(-30 + 20 * log10(max(ir2bwh))), round(3 + 20 * log10(max(ir2bwh)))]);
	grid("on");
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = -40;
	gax(4) = 0;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	subplot(1,2,2);	
	axis(gax);
	safetics("x",gax(1):2:gax(2));
	
	# Print to the output file
	print([ fpath fprefix"-ETC-1-8kHz" fext ],fdevice);
	
	# Remove variables no longer used
	clear ir1bw ir2bw ir1bwh ir2bwh;

	
##############################################################################	
	# Report the stage
	disp("Unsmoothed frequency response, 1 ms window...");
	fflush(stdout);
	
	# Computes the window, 1 ms
	wind = [ones(1,floor(fs/100)) ones(1,floor(fs/2000)) (blackman(floor(fs/1000))(1 + floor(fs/2000):fs/1000))' zeros(1,8192 - (fs/100 + floor(fs/1000)))]';
	
	# Extract the 1ms windowed impulse responses
	ir1w = ir1n([ic1-fs/100:ic1+(8192 - (1 + fs/100))]) .* wind;
	ir1w = fft([ir1w(1 + fs/100:length(ir1w))' ir1w(1:fs/100)']);
	ir1w = ir1w/max(ir1w);
	
	ir2w = ir2n([ic2-fs/100:ic2+(8192 - (1 + fs/100))]) .* wind;
	ir2w = fft([ir2w(1 + fs/100:length(ir2w))' ir2w(1:fs/100)']);	
	ir2w = ir2w/max(ir2w);
	
	# Compute the index limits
	ixl = floor(1000 * length(ir1w) / fs);
	ixu = ceil(20000 * length(ir1w) / fs);
	ixg = [ixl:ixu];
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,2,2);
	hold("on");

	# Plot the magnitude response 1
	subplot(1,2,1);
	semilogx(0.001 * fs * ixg / length(ir1w), 20 * log10(abs(ir1w(ixg))),["3;" irname1 ";"],"LineWidth",DLW);
	axis([1, 20]);
	grid("on");
	safetics("x",[1,1.5,2,3,4,5,6,8,10,13,16,20]);
	title("Frequency response, 1 ms gating");	

	# Plot the magnitude response 2
	subplot(1,2,2);
	semilogx(0.001 * fs * ixg / length(ir2w),20 * log10(abs(ir2w(ixg))),["1;" irname2 ";"],"LineWidth",DLW);

	axis([1, 20]);
	grid("on");
	safetics("x",[1,1.5,2,3,4,5,6,8,10,13,16,20]);
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = -30;
	gax(4) = 3;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Disable holding the plot and set graph parameters
	subplot(1,2,2);
	hold("off");
		
	# Print to the output file
	print([ fpath fprefix"-FR-Unsmoothed-1ms" fext ],fdevice);

	
##############################################################################	
	# Report the stage
	disp("Unsmoothed frequency response, 5 ms window...");
	fflush(stdout);
	
	# Computes the window, 5 ms
	wind = [ones(1,fs/100) ones(1,floor(fs/200)) (blackman(floor(fs/100))(floor(fs/200+1):floor(fs/100)))' zeros(1,8192 - (fs/100 + floor(fs/100)))]';
	
	# Extract the 5ms windowed impulse responses
	ir1w = ir1n([ic1-fs/100:ic1+(8192 - (fs/100 + 1))]) .* wind;
	ir1w = fft([ir1w(fs/100+1:length(ir1w))' ir1w(1:fs/100)']);
	ir1w = ir1w/max(ir1w);
	
	ir2w = ir2n([ic2-fs/100:ic2+(8192 - (fs/100 + 1))]) .* wind;
	ir2w = fft([ir2w(fs/100+1:length(ir2w))' ir2w(1:fs/100)']);	
	ir2w = ir2w/max(ir2w);
		
	# Compute the index limits
	ixl = floor(200 * length(ir1w) / fs);
	#ixu = ceil(40000 * length(ir1w) / fs);
	ixu = ceil(20000 * length(ir1w) / fs);
	ixg = ixl:ixu;
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
 
	# Plot the magnitude response 1
	subplot(1,2,1);
	semilogx(0.001 * fs * ixg / length(ir1w),20 * log10(abs(ir1w(1 + ixg))),["3;" irname1 ";"],"LineWidth",DLW);	
	axis([0.2, 20]);
	grid("on");
	safetics("x",[0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:15);
	title("Frequency response, 5 ms gating");	
	
	# Plot the magnitude response 2
	subplot(1,2,2);
	semilogx(0.001 * fs * ixg / length(ir2w),20 * log10(abs(ir2w(1 + ixg))),["1;" irname2 ";"],"LineWidth",DLW);
	axis([0.2, 20]);
	grid("on");
	safetics("x",[0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-15:3:15);
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = -30;
	gax(4) = 3;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Print to the output file
	print([ fpath fprefix"-FR-Unsmoothed-5ms" fext ],fdevice);
		
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");

	angle1 = 180 * angle(ir1w([2:length(ir1w)/2]))/pi;
	#angle1 = interpft(angle1, 50);
	angle2 = 180 * angle(ir2w([2:length(ir2w)/2]))/pi;
	#angle2 = interpft(angle2, 50);
	
	rows(angle1)
	columns(angle1)
	
	# Plot the phase responses
	subplot(1,2,1);
	ixg= [1:columns(interpft(angle1,50))];
	semilogx(0.001*ixg*fs/(2*columns(interpft(angle1,50))), interpft(angle1,50), ["3;" irname1 ";"],"LineWidth",DLW);
	ixg= [1:columns(angle2)];	
	semilogx(0.001*ixg*fs/(2*columns(angle2)), angle2, ["1;" irname2 ";"],"LineWidth",DLW);
	axis([0.2, 20, -180, 180]);
	grid("on");
 
	safetics("x",[0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-180:30:180);
	title("Phase 5 ms gating");

	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
				
	deltaangle = (180*(angle(ir1w)-angle(ir2w))/pi);
	deltaangle = interpft(deltaangle,50);
	
	# Plot the phase difference 1
	subplot(1,2,2);
	ixg= [1:columns(deltaangle)];	
	semilogx(0.001*ixg*fs/(2*columns(deltaangle)), deltaangle,["1;" "phase difference" ";"],"LineWidth",DLW);
	axis([0.2, 20, -180, 180]);
	grid("on");
 
	safetics("x",[0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-180:30:180);
	title("Phase difference 5 ms gating");
			
	# Print to the output file
	print([ fpath fprefix"-Phase-5ms" fext ],fdevice);
	
	
##############################################################################	
	# Report the stage
	disp("Unsmoothed frequency response, 700 ms window...");
	fflush(stdout);

	# Computes the window, about 700 ms
	ir1w = ir1n(ic1-32767:ic1+32768);
	ir1w = fft([ir1w(1+floor(0.3*fs):length(ir1w))' zeros(1,131072 - length(ir1w)) ir1w(1:floor(0.3*fs))']);	
	ir1w = ir1w/max(ir1w);	
	
	ir2w = ir2n(ic2-32767:ic2+32768);
	ir2w = fft([ir2w(1+floor(0.3*fs):length(ir2w))' zeros(1,131072 - length(ir2w)) ir2w(1:floor(0.3*fs))']);
	ir2w = ir2w/max(ir2w);
	
	# Compute the index limits
	ixl = floor(20 * length(ir1w) / fs);
	ixu = ceil(300 * length(ir1w) / fs);
	ixg = ixl:ixu;
		
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Plot the magnitude response 1
	subplot(1,2,1);
	semilogx(fs * ixg / length(ir1w),20 * log10(abs(ir1w(ixg))),["3;" irname1 ";"],"LineWidth",DLW);
	axis([20, 300]);
	grid("on");
	safetics("x",[20,30,40,50,60,80,100,120,150,200,250,300]);
	title("Frequency response, 700 ms gating");	
		
	# Plot the magnitude response 2
	subplot(1,2,2);
	semilogx(fs * ixg / length(ir2w),20 * log10(abs(ir2w(ixg))),["1;" irname2 ";"],"LineWidth",DLW);
	axis([20, 300]);
	grid("on");
	safetics("x",[20,30,40,50,60,80,100,120,150,200,250,300]);
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = -30;
	gax(4) = 3;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Print to the output file
	print([ fpath fprefix"-FR-Unsmoothed-700ms" fext ],fdevice);

			
##############################################################################			
	# Report the stage
	disp("Spectrogram 20 ms window...");
	fflush(stdout);
	
# Spectrogram from -1 to +20 ms
	tbs = 2;
	tbe = 20;
	sbs = 240;
	sas = 1200;
	sfs = 256;
	sol = 2;
	mlb = -30;
			
	# 0.5 ms spectrogram window
	swl = 24;
	
	# Computes the spectrogram window
	wind = [blackman(swl)' zeros(1,sfs-swl)]';
	
	[irm1, icc1] = max(abs(irconv1b));
	[S1, f1, t1] = specgram(irconv1b((icc1 - (-1 + sbs + swl/2)):(icc1 + (sas + sfs))),sfs,fs,wind,sfs - sol);	
	S1 = abs(S1);
	S1 = S1/max(S1(:));
	S1 = 20 * log10(max(S1,10^(mlb/20)));
	
	[irm2, icc2] = max(abs(irconv2b));
	[S2, f2, t2] = specgram(irconv2b((icc2 - (-1 + sbs + swl/2)):(icc2 + (sas + sfs))),sfs,fs,wind,sfs - sol);
	S2 = abs(S2);
	S2 = S2/max(S2(:));
	S2 = 20 * log10(max(S2,10^(mlb/20)));

	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
		
	# Plot the spectrogram 1
	subplot(1,2,1);	
	imagesc(1000 * (t1 - (sbs/fs)),0.001 * f1,S1);
	set(gca(),"ydir","normal");
	axis([-tbs, tbe, 0, fs/2400]);
	grid("on");	
	zlabel("Mag. (dB)");
	text(1.1 * tbe,fs / 4000,"Mag. (dB)","Rotation",90,"HorizontalAlignment","center");
	colormap(EDCMap);	
	colorbar("EastOutside");
	title(irname1);
	
	# Plot the spectrogram 2
	subplot(1,2,2);	
	imagesc(1000 * (t2 - (sbs/fs)),0.001*f2,S2);
	set(gca(),"ydir","normal");
	axis([-tbs, tbe, 0, fs/2400]);
	grid("on");	
	zlabel("Mag. (dB)");
	text(1.1 * tbe,fs / 4000,"Mag. (dB)","Rotation",90,"HorizontalAlignment","center");
	colormap(EDCMap);	
	colorbar("EastOutside");
	title(irname2);	
		
	# Print to the output file
	print([ fpath fprefix"-Spectrogram-20ms" fext ],fdevice);
	

##############################################################################
	# Report the stage
	disp("Various gating times...");
	fflush(stdout);
	
	# Windows array, in ms
	wlst = [100 30 10 3 1];
	# Graph resolution
	gres = 16384;
	# Graph pregap
	gpgp = 480;
	# Scaling base (dB)
	scbs = 14;
	# Scaling delta (dB)
	scdt = -6;
	
	# Compute the index limits
	ixl = floor(2 * 20 * gres / fs);
	ixu = ceil(2 * 20000 * gres / fs);
			
	# Open a new plot	
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	subplot(1,2,2);
	hold("on");
	
	# Cycle on the windows sizes
	cscl = scbs;
	cg = 1;
	for cws = wlst
		# Computes the number of samples for the current window
		wns = round(fs * cws / (2 * 1000));
		
		# Creates the response prewindow
		wind = [ones(1,gpgp) ones(1,wns) (blackman(2 * wns)((wns + 1):(2 * wns)))' zeros(1,gres - (gpgp + 2 * wns))]';
		
		# Extract the windowed impulse responses
		ir1w = ir1n([(ic1 - gpgp):(ic1 + (gres - (gpgp + 1)))]) .* wind;
		ir1w = ir1w(:)/max(abs(ir1w));		
		ir1m = ssev(ir1w,fs,0.15,1);	
		
		ir2w = ir2n([(ic2 - gpgp):(ic2 + (gres - (gpgp + 1)))]) .* wind;
		ir2w = ir2w(:)/max(abs(ir2w));
		ir2m = ssev(ir2w,fs,0.15,1);
		
		% # Computes the graph lower bounds
		glb = fs / (0.7 * wns);
		glb = round(glb / (fs / (2 * gres)));
		glb = max(glb,2);
		
		# Computes the graph index
		ixg = max(ixl,glb):ixu;
		# Plot the magnitude response
		subplot(1,2,1);
		semilogx(0.001 * 0.5 * fs * ixg / gres, cscl + 20 * log10(ir1m(1+ixg)),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		subplot(1,2,2);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + 20 * log10(ir2m(1+ixg)),"color",hsv2rgb([0, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
		# Adjust the scaling
		cscl = cscl + scdt;
		cg = cg + 1;
	endfor	
	
	subplot(1,2,1);
	hold("off");
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	grid("on");
	legend(3);
	title(["Frequency response, 1-3-10-30-100 ms gatings " irname1 ]);
	
	subplot(1,2,2);
	hold("off");
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	grid("on");
	legend(3);
	title(irname2);	
	
	# Save the axis range
	subplot(1,2,1);
	axis([0.02, 20]);	
	subplot(1,2,2);
	axis([0.02, 20]);	

	# Computes the uniform axis range
	gax = axis();
	gax(3) = -20;
	gax(4) = 40;
	
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	
	# Print to the output file
	print([ fpath fprefix"-Various-gatings" fext ],fdevice);

	
	
##############################################################################
	# Report the stage
	disp("1/3 and 1/6 of octave");
	fflush(stdout);

	conv1_fft3 = ssev(ir1n,fs,0.33,1);
	conv1_fft3 = conv1_fft3/mean(conv1_fft3(fs/300:fs/20));
	
	conv2_fft3 = ssev(ir2n,fs,0.33,1);
	conv2_fft3 = conv2_fft3/mean(conv2_fft3(fs/300:fs/20));
	
	conv1_fft6 = ssev(ir1n,fs,0.15,1);
	conv1_fft6 = conv1_fft6/mean(conv1_fft6(fs/300:fs/20));
	
	conv2_fft6 = ssev(ir2n,fs,0.15,1);	
	conv2_fft6 = conv2_fft6/mean(conv2_fft6(fs/300:fs/20));
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	grid("on");	
	axis([0.02, 20]);	
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title("Frequency response 1/3 octave");
	
	subplot(1,2,2);
	hold("on");
	grid("on");	
	axis([0.02, 20]);	
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title("Frequency response 1/6 octave");	
	
	subplot(1,2,1);	
	ixg = [1:columns(conv1_fft3)];	
	semilogx(0.001*ixg*fs/(2*columns(conv1_fft3)), 20*log10(conv1_fft3(ixg)),["3;" irname1 ";"],"LineWidth",DLW);	
	ixg = [1:columns(conv2_fft3)];
	semilogx(0.001*ixg*fs/(2*columns(conv2_fft3)), 20*log10(conv2_fft3(ixg)),["1;" irname2 ";"],"LineWidth",DLW);	

	if (limits == 1)
	disp ('AES-EBU');
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1n)),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1n)),min(-3,0.8-3*log10(0.01 * fs * ixg / length(ir1n))),["2;" "AES-EBU limits" ";"],"LineWidth",DLW);

	elseif (limits == 2)
	disp ('BK');
	semilogx(0.001 * fs * ixg / length(ir1n),min(1.5,2-2*log10(0.01 * fs * ixg / length(ir1n))),["2;" "BK target" ";"],"LineWidth",DLW);
		
	elseif (limits == 3)
	disp ('SMPTE small room');
	semilogx(0.001 * fs * ixg / length(ir1n),min(3,min(12-7*log10(0.01 * fs * ixg / length(ir1n)),min(38-20*log10(0.01 * fs * ixg / length(ir1n)),5+7*log10(0.01 * fs * ixg / length(ir1n))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1n),min(-3,min(6-7*log10(0.01 * fs * ixg / length(ir1n)),min(32-20*log10(0.01 * fs * ixg / length(ir1n)),2+18*log10(0.01 * fs * ixg / length(ir1n))))),["2;" "SMPTE small room" ";"],"LineWidth",DLW);
		
	elseif (limits == 4)
	disp ('SMPTE mid room');
	semilogx(0.001 * fs * ixg / length(ir1n),min(3,min(16-10*log10(0.01 * fs * ixg / length(ir1n)),min(36-20*log10(0.01 * fs * ixg / length(ir1n)),5+7*log10(0.01 * fs * ixg / length(ir1n))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1n),min(-3,min(10-10*log10(0.01 * fs * ixg / length(ir1n)),min(48-30*log10(0.01 * fs * ixg / length(ir1n)),2+18*log10(0.01 * fs * ixg / length(ir1n))))),["2;" "SMPTE medium room" ";"],"LineWidth",DLW);
	
	elseif (limits == 5)
	disp ('SMPTE large room');	
	semilogx(0.001 * fs * ixg / length(ir1n),min(3,min(22.5-15*log10(0.01 * fs * ixg / length(ir1n)),min(57-30*log10(0.01 * fs * ixg / length(ir1n)),5+7*log10(0.01 * fs * ixg / length(ir1n))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1n),min(-3,min(16.5-15*log10(0.01 * fs * ixg / length(ir1n)),min(45-30*log10(0.01 * fs * ixg / length(ir1n)),2+18*log10(0.01 * fs * ixg / length(ir1n))))),["2;" "SMPTE large room" ";"],"LineWidth",DLW);
	
	elseif (limits == 6)
	disp ('Dolby X-curve');	
	semilogx(min(0.1,0.001 * fs * ixg / length(ir1n)),10*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1n),min(0,min(14.2-11*log10(0.01 * fs * ixg / length(ir1n)),2+7*log10(0.01 * fs * ixg / length(ir1n)))),["2;" "Dolby X-curve" ";"],"LineWidth",DLW);
			
	else
	disp ('custom');	
	semilogx(0.001 * fs * ixg / length(ir1n),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1n),-3*(1+ixg-ixg),["2;" "custom" ";"],"LineWidth",DLW);
	endif	
	
	subplot(1,2,2);	
	ixg = [1:columns(conv1_fft6)];	
	semilogx(0.001*ixg*fs/(2*columns(conv1_fft6)), 20*log10(conv1_fft6(ixg)),["3;" irname1 ";"],"LineWidth",DLW);	
	ixg = [1:columns(conv2_fft6)];
	semilogx(0.001*ixg*fs/(2*columns(conv2_fft6)), 20*log10(conv2_fft6(ixg)),["1;" irname2 ";"],"LineWidth",DLW);		
	
	# Computes the uniform axis range
	g1ax = axis();
	subplot(1,2,1);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	g1ax = axis();
	subplot(1,2,2);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;	
	axis(gax);
	safetics("y",gax(3):3:gax(4));		
		
	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	subplot(1,2,2);
	hold("off");
	
	# Print to the output file
	print([ fpath fprefix"-FR-octave-3-6" fext ],fdevice);
	
##############################################################################		
# Report the stage
	disp("Psychoacoustic response...");
	fflush(stdout);
	
	# Extract the windowed impulse responses
	ir1w = ir1n(ic1-32767:ic1+32768);	
	ir2w = ir2n(ic2-32767:ic2+32768);	
	
	# Performs the frequency dependant windowing of 10 periods	
	ir1w10 = irslprefilt(ir1w,32758,20/fs,floor(fs*10/20),20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w10 = [ zeros(1,65536 - length(ir1w10)) ir1w10(:)' ];
	ir1w10 = ssev(ir1w10,fs,0.1,1);		
	ir1w10 = ir1w10/mean(ir1w10(fs/300:fs/20));	

	ir2w10 = irslprefilt(ir2w,32758,20/fs,floor(fs*10/20),20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w10 = [ zeros(1,65536 - length(ir2w10)) ir2w10(:)' ];
	ir2w10 = ssev(ir2w10,fs,0.1,1);	
	ir2w10 = ir2w10/mean(ir2w10(fs/300:fs/20));

	# Performs the psychoacoustic frequency dependant windowing warped with LFW and HFW gating
	ir1wa = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir1wa = [ zeros(1,65536 - length(ir1wa)) ir1wa(:)' ];
	ir1ma = ssev(ir1wa,fs,smoothtype,SE,'prepeak');
	ir1ma = ir1ma/mean(ir1ma(fs/300:fs/20));
	
	ir2wa = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir2wa = [ zeros(1,65536 - length(ir2wa)) ir2wa(:)' ];
	ir2ma = ssev(ir2wa,fs,smoothtype,SE,'prepeak');	
	ir2ma = ir2ma/mean(ir2ma(fs/300:fs/20));

	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");

	# Enable holding the plot	
	subplot(1,2,1);
	hold("on");
	grid("on");
	axis([0.02, 20]);
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title("Frequency response, adaptive window 10 periods");

	ixg= [1:columns(ir1w10)];	
	semilogx(0.001*ixg*fs/(2*columns(ir1w10)), 20*log10(ir1w10(ixg)),["3;" irname1 ";"],"LineWidth",DLW);	
	ixg= [1:columns(ir2w10)];		
	semilogx(0.001*ixg*fs/(2*columns(ir2w10)), 20*log10(ir2w10(ixg)),["1;" irname2 ";"],"LineWidth",DLW);	

	# Computes the uniform axis range
	subplot(1,2,1);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;	
	axis(gax);
	safetics("y",gax(3):3:gax(4));	
	hold("off");
	
	subplot(1,2,2);
	hold("on");
	grid("on");		
	axis([0.02, 20]);	
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title(["Psychoacoustic frequency response " sprintf(" %.0f-%.0fms, WE %.1f, smooth %.2f, SE %.0f",HFW, LFW, WEG, smoothtype,SE) ""])

	subplot(1,2,2);
	ixg= [1:columns(ir1ma)];	
	semilogx(0.001*ixg*fs/(2*columns(ir1ma)),20 * log10(ir1ma(ixg)),["3;" irname1 ";"],"LineWidth",DLW);
	ixg= [1:columns(ir2ma)];	
	semilogx(0.001*ixg*fs/(2*columns(ir2ma)),20 * log10(ir2ma(ixg)),["1;" irname2 ";"],"LineWidth",DLW);

	# Computes the uniform axis range
	g1ax = axis();
	subplot(1,2,2);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	hold("off");
	
	# Print to the output file
	print([ fpath fprefix"-Psychoacoustic" fext ],fdevice);


##############################################################################		
	# Report the stage
	disp("Compare levels...");
	fflush(stdout);

	conv1_fft3 = ssev(ir1nn,fs,0.33,1);
	conv1_fft4 = conv1_fft3/mean(conv1_fft3(fs/300:fs/20));
	
	conv2_fft3 = ssev(ir2nn,fs,0.33,1);	
	conv2_fft4 = conv2_fft3/mean(conv1_fft3(fs/300:fs/20));
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	grid("on");	
	axis([0.02, 20]);	
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title("Frequency response 1/3 octave, level not normalised");
	
	subplot(1,2,1);	
	ixg = [1:columns(conv1_fft4)];	
	semilogx(0.001*ixg*fs/(2*columns(conv1_fft4)), 20*log10(conv1_fft4(ixg)),["3;" irname1 ";"],"LineWidth",DLW);	
	ixg = [1:columns(conv2_fft4)];
	semilogx(0.001*ixg*fs/(2*columns(conv2_fft4)), 20*log10(conv2_fft4(ixg)),["1;" irname2 ";"],"LineWidth",DLW);	

	# Computes the uniform axis range
	subplot(1,2,1);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;	
	axis(gax);
	safetics("y",gax(3):3:gax(4));	
	hold("off");


	# Performs the psychoacoustic frequency dependant windowing warped with LFW and HFW gating
	ir1w = ir1nn(ic1-32767:ic1+32768);	
	ir1wa = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir1wa = [ zeros(1,65536 - length(ir1wa)) ir1wa(:)' ];	
	ir1ma = ssev(ir1wa,fs,smoothtype,SE,'prepeak');
	ir1mam = ir1ma/mean(ir1ma(fs/300:fs/20));

	ir2w = ir2nn(ic2-32767:ic2+32768);	
	ir2wa = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*3*HFW/2000),WEG,4096,1.0,10,0);
	ir2wa = [ zeros(1,65536 - length(ir2wa)) ir2wa(:)' ];
	ir2ma = ssev(ir2wa,fs,smoothtype,SE,'prepeak');	
	ir2mam = ir2ma/mean(ir1ma(fs/300:fs/20));

	subplot(1,2,2);
	hold("on");
	grid("on");		
	axis([0.02, 20]);	
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);	
	title(["Psychoacoustic frequency response " sprintf(" %.0f-%.0fms, WE %.1f, smooth %.2f, SE %.0f",HFW, LFW, WEG, smoothtype,SE) ""])
	
	# Compute the index limits
	subplot(1,2,2);
	ixg = [1:columns(ir1mam)];		
	semilogx(0.001*ixg*fs/(2*columns(ir1mam)),20 * log10(ir1mam(ixg)),["3;" irname1 ";"],"LineWidth",DLW);
	ixg = [1:columns(ir2mam)];		
	semilogx(0.001*ixg*fs/(2*columns(ir2mam)),20 * log10(ir2mam(ixg)),["1;" irname2 ";"],"LineWidth",DLW);

	# Computes the uniform axis range
	g1ax = axis();
	subplot(1,2,2);	
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 15;
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	hold("off");

	# Print to the output file
	print([ fpath fprefix"-levels" fext ],fdevice);
	
	# Remove variables no longer used
	clear wind ir1w ir1m ir2w ir2m ir3w ir3m ixl ixu ixg g3ax gax;	
	
##############################################################################	
	# Report the stage
	disp("RT60...");
	fflush(stdout);
		
	# Compute RT60
	[cf, fb] = octbands();
	ir1r = real(ir1n(:)/max(ir1n));	
	rt1 = rt60(fs,ir1r,-1,fb,-5,-10,16384,90);
	
	ir2r = real(ir2n(:)/max(ir2n));	
	rt2 = rt60(fs,ir2r,-1,fb,-5,-10,16384,90);
	
	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	subplot(1,2,2);
	hold("on");
		
	# Extract the windowed impulse responses
	ir1w = ir1n(ic1-fs/2:ic1+fs/2);
	ir2w = ir2n(ic2-fs/2:ic2+fs/2);
	
	# Pad the windowed impulse response
	ir1w = [ zeros(1,65536 - length(ir1w)) ir1w(:)' ];
	ir2w = [ zeros(1,65536 - length(ir2w)) ir2w(:)' ];	
			
	# Compute the index limits
	ixl = floor(20 * length(ir1w) / fs);
	ixu = ceil(40000 * length(ir1w) / fs);
	ixg = ixl:ixu;
			
	# Plot the magnitude response 1
	subplot(1,2,1);
	semilogx(0.001 * fs * 5.47*cf / length(ir1),rt1,["3;" irname1 ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * 5.47*cf / length(ir2),rt2,["1;" irname2 ";"],"LineWidth",DLW);
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.063,0.125,0.25,0.5,1,2,4,8]);
	title("RT60 per octave, s / kHz");
				
	[cf, fb] = oct3bands();
	rt1 = rt60(fs,ir1r,-1,fb,-5,-10,16384,90);
	rt2 = rt60(fs,ir2r,-1,fb,-5,-10,16384,90);
						
	# Plot the RT60
	subplot(1,2,2);
	semilogx(0.001 * fs * 5.47*cf / length(ir1),rt1,["3;" irname1 ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * 5.47*cf / length(ir2),rt2,["1;" irname2 ";"],"LineWidth",DLW);
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.02,0.03,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);		
	title("RT60 fine resolution, s / kHz");
	
	# Disable holding the plot and set graph parameters
	subplot(1,2,1);
	hold("off");
	subplot(1,2,2);
	hold("off");
	
	# Computes the uniform axis range
	gax = axis();
	gax(3) = 0;
	gax(4) = 1;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):0.1:gax(4));
		
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):0.1:gax(4));
		
	# Print to the output file
	print([ fpath fprefix"-RT60" fext ],fdevice);
	
	# Remove variables no longer used
	clear wind ir1w ir1m ir2w ir2m ixl ixu ixg gax;
		
	# Reset to the standard colormap
	colormap("default");
	
	# Remove variables no longer used
	clear S1 S2;

		
##############################################################################		
	# Report the stage
	disp("Wavelet cycle/octave scalogram, medium time resolution...");
	fflush(stdout);
	
	# Morlet cycle/octave scalogram from -5 cycles to +25 cycles
	# 20 Hz to 20 kHz
	# 100 frequency points and 350 cycle points
	cecb = -5;
	cece = 25;
	cenc = 350;
	cesf = 20;
	ceef = 20000;
	cenf = 100;
	
	# Upsampling and filtering
	cefl = 32768;
	ceat = 120;
	ceuf = 8;
	cewm = 2;
	
	# Morlet wavelet
	ceft = 2;
			
	# Computes the cycle points
	cecp = linspace(cecb,cece,cenc);
	
	# Computes the frequency points
	cebs = 2 ^ (log2(ceef / cesf) / cenf); 
	cefp = logspace(log10(2 * cesf / (cebs * fs)),log10(2 * ceef / (cebs * fs)),cenf);
	
	# Computes the Morlet cycle/octave scalogram
	ce1 = tfir(ir1, ic1, cecp, cefp, cefl, ceat, ceuf, ceft, cewm);
	ce2 = tfir(ir2n, ic2, cecp, cefp, cefl, ceat, ceuf, ceft, cewm);
	
	# Remaps the frequency points for plotting
	cefp = logspace(log10(2 * cesf / fs),log10(2 * ceef / fs),cenf);
	
	# Computes the envelope
	for I = 1:cenf
		ce1(I,:) = abs(hilbert(ce1(I,:)));
		ce2(I,:) = abs(hilbert(ce2(I,:)));
	endfor
		
	# Remaps the frequency points for plotting
	cefp = logspace(log10(2 * cesf / fs),log10(2 * ceef / fs),cenf);
	
	# Normalize the enveloppe
	ce1 = ce1/max(ce1(:));
	ce2 = ce2/max(ce2(:));
	
	# Resample the scalogram for image plotting
	scrf = 4;
	scff = 8;
	rcecp = linspace(cecb,cece,cenc * scrf);
	rcenf = scff * cenf;
	rce1 = pchip2d(cecp,0:(cenf-1),ce1,rcecp,linspace(0,cenf-1,rcenf));
	rce2 = pchip2d(cecp,0:(cenf-1),ce2,rcecp,linspace(0,cenf-1,rcenf));
		
	# Convert to log scale
	ce1 = 20 * log10(max(ce1,10^(-30/20)));
	ce2 = 20 * log10(max(ce2,10^(-30/20)));
	
	# Reset to the standard colormap
	colormap("default");
	
	# Resample the scalogram for image plotting
	scrf = 4;
	scff = 8;
	rcecp = linspace(cecb,cece,cenc * scrf);
	rcenf = scff * cenf;
	rce1 = pchip2d(cecp,0:(cenf-1),ce1,rcecp,linspace(0,cenf-1,rcenf));
	rce2 = pchip2d(cecp,0:(cenf-1),ce2,rcecp,linspace(0,cenf-1,rcenf));	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
		
	# Plot the scalogram map 1
	subplot(1,2,1);	
	imagesc(rcecp,0:rcenf-1,rce1);
	set(gca(),"ydir","normal");	
	axis([cecb, cece, 0, rcenf-1]);
	grid("on");	
	#ylabel("Frequency (kHz)");	
	zlabel("Mag. (dB)");
	text(1.1 * cece,rcenf / 2,"Mag. (dB)","Rotation",90,"HorizontalAlignment","center");
	safetics("y",linspace(0,rcenf-1,10),["0.02";"0.05";"0.1";"0.2";"0.5";"1";"2";"5";"10";"20"]);	
	safetics("z",-25:5:5);
	colormap(EDCMap);	
	colorbar("EastOutside");
	title(["Wavelet -5 to 25 periods, " irname1 ]);
		
	# Plot the scalogram map 2
	subplot(1,2,2);	
	imagesc(rcecp,0:rcenf-1,rce2);
	set(gca(),"ydir","normal");	
	axis([cecb, cece, 0, rcenf-1]);
	grid("on");	
	#xlabel("Time (cycles)");
	#ylabel("Frequency (kHz)");	
	zlabel("Mag. (dB)");
	text(1.1 * cece,rcenf / 2,"Mag. (dB)","Rotation",90,"HorizontalAlignment","center");
	safetics("y",linspace(0,rcenf-1,10),["0.02";"0.05";"0.1";"0.2";"0.5";"1";"2";"5";"10";"20"]);	
	safetics("z",-25:5:5);
	colormap(EDCMap);	
	colorbar("EastOutside");
	title(irname2);	
		
	# Print to the output file
	print([ fpath fprefix"-Wavelet-ETC" fext ],fdevice);
		
	# Reset to the standard colormap
	colormap("default");
	
	# Remove variables no longer used
	clear cecp rcecp cefp ce1 ce2 rce1 rce2;

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);