## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of DRC - Digital room correction

## usage: create3multiplots(ir1,ic1,it1,ir2,ic2,it2,outdir,fprefix,fext,fdevice)
##
##
##
## ir1 = impulse response 1
## ic1 = center sample of impulse response 1, -1 for automatic search
## it1 = title for impulse response 1 plots
## ir2 = impulse response 2
## ic2 = center sample of impulse response 2, -1 for automatic search
## it2 = title for impulse response 2 plots
## outdir = output directory for graph files
## fprefix = prefix for graph files
## fext = extension for graph files, default '.eps'
## fdevice = print device for graph files, default '-depsc'
##  
## script for Align2, by Jean-Luc Ohl
# psychoacoustic curve smoothtype = -2 for ERB, -1 for Bark, 0.33 for 1/3 octave, 0.15 for 1/6 octave,...


function create3multiplots(ir1,ic1,it1,ir2,ic2,it2,ir3,ic3,it3,outdir,fprefix,fext = '.eps',fdevice = '-S640,480 -deps')



fs=48000;
fdevice = '-S1200,220';
limits = 4;
HFW = 3;
LFW = 300;
WEG = 1;
smoothtype = 0.08;
SE = 10;
mic = load('C:\Users\jlo\Desktop\align2\files\mic\kt-vert1.txt');


ir1b = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L2.wav1.pcm');
ir1c = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L3.wav1.pcm');
ir1d = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L5.wav1.pcm');
ir1e = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L7.wav1.pcm');
ir1f = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L8.wav1.pcm');
ir1g = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L9.wav1.pcm');
ir1h = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L10.wav1.pcm');
ir1i = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L12.wav1.pcm');
ir1j = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\L13.wav1.pcm');
ir2b = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C2.wav2.pcm');
ir2c = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C3.wav2.pcm');
ir2d = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C7.wav2.pcm');
ir2e = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C8.wav2.pcm');
ir2f = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C9.wav2.pcm');
ir2g = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C10.wav2.pcm');
ir2h = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C13.wav2.pcm');
ir2i = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C14.wav2.pcm');
ir2j = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\C16.wav2.pcm');
ir3b = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R2.wav3.pcm');
ir3c = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R3.wav3.pcm');
ir3d = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R4.wav3.pcm');
ir3e = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R6.wav3.pcm');
ir3f = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R7.wav3.pcm');
ir3g = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R8.wav3.pcm');
ir3h = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R9.wav3.pcm');
ir3i = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R11.wav3.pcm');
ir3j = loadpcm('C:\Users\jlo\Desktop\align2\measurements\sledge-audi3-2012-06-14m\R12.wav3.pcm');

















	
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9) 


	ir1 = [ zeros(1,65536) ir1(:)' ];
	ir1 = [ ir1(:)' zeros(1,65536) ];
	ir1b = [ zeros(1,65536) ir1b(:)' ];
	ir1b = [ ir1b(:)' zeros(1,65536) ];		
	ir1c = [ zeros(1,65536) ir1c(:)' ];
	ir1c = [ ir1c(:)' zeros(1,65536) ];	
	ir1d = [ zeros(1,65536) ir1d(:)' ];		
	ir1d = [ ir1d(:)' zeros(1,65536) ];	
	ir1e = [ zeros(1,65536) ir1e(:)' ];
	ir1e = [ ir1e(:)' zeros(1,65536) ];	
	ir1f = [ zeros(1,65536) ir1f(:)' ];
	ir1f = [ ir1f(:)' zeros(1,65536) ];		
	ir1g = [ zeros(1,65536) ir1g(:)' ];
	ir1g = [ ir1g(:)' zeros(1,65536) ];	
	ir1h = [ zeros(1,65536) ir1h(:)' ];		
	ir1h = [ ir1h(:)' zeros(1,65536) ];	
	ir1i = [ zeros(1,65536) ir1i(:)' ];
	ir1i = [ ir1i(:)' zeros(1,65536) ];		
	ir1j = [ zeros(1,65536) ir1j(:)' ];
	ir1j = [ ir1j(:)' zeros(1,65536) ];		
	
	ir2 = [ zeros(1,65536) ir2(:)' ];
	ir2 = [ ir2(:)' zeros(1,65536) ];	
	ir2b = [ zeros(1,65536) ir2b(:)' ];	
	ir2b = [ ir2b(:)' zeros(1,65536) ];	
	ir2c = [ ir2c(:)' zeros(1,65536) ];
	ir2c = [ zeros(1,65536) ir2c(:)' ];	
	ir2d = [ ir2d(:)' zeros(1,65536) ];	
	ir2d = [ zeros(1,65536) ir2d(:)' ];	
	ir2e = [ zeros(1,65536) ir2e(:)' ];	
	ir2e = [ ir2e(:)' zeros(1,65536) ];	
	ir2f = [ zeros(1,65536) ir2f(:)' ];	
	ir2f = [ ir2f(:)' zeros(1,65536) ];	
	ir2g = [ zeros(1,65536) ir2g(:)' ];
	ir2g = [ ir2g(:)' zeros(1,65536) ];
	ir2h = [ zeros(1,65536) ir2h(:)' ];	
	ir2h = [ ir2h(:)' zeros(1,65536) ];	
	ir2i = [ zeros(1,65536) ir2i(:)' ];	
	ir2i = [ ir2i(:)' zeros(1,65536) ];		
	ir2j = [ zeros(1,65536) ir2j(:)' ];	
	ir2j = [ ir2j(:)' zeros(1,65536) ];		
	
	
	ir3 = [ zeros(1,65536) ir3(:)' ];	
	ir3 = [ ir3(:)' zeros(1,65536) ];	
	ir3b = [ zeros(1,65536) ir3b(:)' ];	
	ir3b = [ ir3b(:)' zeros(1,65536) ];	
	ir3c = [ zeros(1,65536) ir3c(:)' ];	
	ir3c = [ ir3c(:)' zeros(1,65536) ];
	ir3d = [ zeros(1,65536) ir3d(:)' ];	
	ir3d = [ ir3d(:)' zeros(1,65536) ];	
	ir3e = [ zeros(1,65536) ir3e(:)' ];	
	ir3e = [ ir3e(:)' zeros(1,65536) ];	
	ir3f = [ zeros(1,65536) ir3f(:)' ];	
	ir3f = [ ir3f(:)' zeros(1,65536) ];	
	ir3g = [ zeros(1,65536) ir3g(:)' ];	
	ir3g = [ ir3g(:)' zeros(1,65536) ];
	ir3h = [ zeros(1,65536) ir3h(:)' ];	
	ir3h = [ ir3h(:)' zeros(1,65536) ];	
	ir3i = [ zeros(1,65536) ir3i(:)' ];	
	ir3i = [ ir3i(:)' zeros(1,65536) ];		
	ir3j = [ zeros(1,65536) ir3j(:)' ];	
	ir3j = [ ir3j(:)' zeros(1,65536) ];	


	
	# Find the impulse center
	[irm1,ic1] = max(abs(hilbert(ir1)));	
	[irm1b,ic1b] = max(abs(hilbert(ir1b)));		
	[irm1c,ic1c] = max(abs(hilbert(ir1c)));		
	[irm1d,ic1d] = max(abs(hilbert(ir1d)));		
	[irm1e,ic1e] = max(abs(hilbert(ir1e)));	
	[irm1f,ic1f] = max(abs(hilbert(ir1f)));		
	[irm1g,ic1g] = max(abs(hilbert(ir1g)));		
	[irm1h,ic1h] = max(abs(hilbert(ir1h)));		
	[irm1i,ic1i] = max(abs(hilbert(ir1i)));	
	[irm1j,ic1j] = max(abs(hilbert(ir1j)));	
	
	[irm2,ic2] = max(abs(hilbert(ir2)));
	[irm2b,ic2b] = max(abs(hilbert(ir2b)));
	[irm2c,ic2c] = max(abs(hilbert(ir2c)));
	[irm2d,ic2d] = max(abs(hilbert(ir2d)));
	[irm2e,ic2e] = max(abs(hilbert(ir2e)));
	[irm2f,ic2f] = max(abs(hilbert(ir2f)));		
	[irm2g,ic2g] = max(abs(hilbert(ir2g)));		
	[irm2h,ic2h] = max(abs(hilbert(ir2h)));		
	[irm2i,ic2i] = max(abs(hilbert(ir2i)));	
	[irm2j,ic2j] = max(abs(hilbert(ir2j)));	

	[irm3,ic3] = max(abs(hilbert(ir3)));
	[irm3b,ic3b] = max(abs(hilbert(ir3b)));
	[irm3c,ic3c] = max(abs(hilbert(ir3c)));
	[irm3d,ic3d] = max(abs(hilbert(ir3d)));
	[irm3e,ic3e] = max(abs(hilbert(ir3e)));
	[irm3f,ic3f] = max(abs(hilbert(ir3f)));		
	[irm3g,ic3g] = max(abs(hilbert(ir3g)));		
	[irm3h,ic3h] = max(abs(hilbert(ir3h)));		
	[irm3i,ic3i] = max(abs(hilbert(ir3i)));	
	[irm3j,ic3j] = max(abs(hilbert(ir3j)));	
	
	# Normalize the impulse responses
	rms1 = norm(ir1);
	ir1 = ir1(:)/rms1;
	rms1b = norm(ir1b);
	ir1b = ir1b(:)/rms1b;	
	rms1c = norm(ir1c);
	ir1c = ir1c(:)/rms1c;	
	rms1d = norm(ir1d);
	ir1d = ir1d(:)/rms1d;	
	rms1e = norm(ir1e);
	ir1e = ir1e(:)/rms1e;	
	rms1f = norm(ir1f);
	ir1f = ir1f(:)/rms1f;	
	rms1g = norm(ir1g);
	ir1g = ir1g(:)/rms1g;	
	rms1h = norm(ir1h);
	ir1h = ir1h(:)/rms1h;	
	rms1i = norm(ir1i);
	ir1i = ir1i(:)/rms1i;		
	rms1j = norm(ir1j);
	ir1j = ir1j(:)/rms1j;	
	
	rms2 = norm(ir2);
	ir2 = ir2(:)/rms2;	
	rms2b = norm(ir2b);
	ir2b = ir2b(:)/rms2b;		
	rms2c = norm(ir2c);
	ir2c = ir2c(:)/rms2c;		
	rms2d = norm(ir2d);
	ir2d = ir2d(:)/rms2d;		
	rms2e = norm(ir2e);
	ir2e = ir2e(:)/rms2e;	
	rms2f = norm(ir2f);
	ir2f = ir2f(:)/rms2f;	
	rms2g = norm(ir2g);
	ir2g = ir2g(:)/rms2g;	
	rms2h = norm(ir2h);
	ir2h = ir2h(:)/rms2h;	
	rms2i = norm(ir2i);
	ir2i = ir2i(:)/rms2i;		
	rms2j = norm(ir2j);
	ir2j = ir2j(:)/rms2j;	

	rms3 = norm(ir3);
	ir3 = ir3(:)/rms3;	
	rms3b = norm(ir3b);
	ir3b = ir3b(:)/rms3b;		
	rms3c = norm(ir3c);
	ir3c = ir3c(:)/rms3c;		
	rms3d = norm(ir3d);
	ir3d = ir3d(:)/rms3d;		
	rms3e = norm(ir3e);
	ir3e = ir3e(:)/rms3e;	
	rms3f = norm(ir3f);
	ir3f = ir3f(:)/rms3f;	
	rms3g = norm(ir3g);
	ir3g = ir3g(:)/rms3g;	
	rms3h = norm(ir3h);
	ir3h = ir3h(:)/rms3h;	
	rms3i = norm(ir3i);
	ir3i = ir3i(:)/rms3i;		
	rms3j = norm(ir3j);
	ir3j = ir3j(:)/rms3j;	


	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display	when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
	
	# Report infos
	disp(sprintf("Frequency : %d,",fs));
	disp(sprintf("IR1 impulse center : %d, max: %f, RMS: %f",ic1, irm1, rms1));
	disp(sprintf("IR1b impulse center : %d, max: %f, RMS: %f",ic1b, irm1b, rms1b));	
	disp(sprintf("IR1c impulse center : %d, max: %f, RMS: %f",ic1c, irm1c, rms1c));
	disp(sprintf("IR1d impulse center : %d, max: %f, RMS: %f",ic1d, irm1d, rms1d));
	disp(sprintf("IR1e impulse center : %d, max: %f, RMS: %f",ic1e, irm1e, rms1e));
	disp(sprintf("IR1f impulse center : %d, max: %f, RMS: %f",ic1f, irm1f, rms1f));	
	disp(sprintf("IR1g impulse center : %d, max: %f, RMS: %f",ic1g, irm1g, rms1g));
	disp(sprintf("IR1h impulse center : %d, max: %f, RMS: %f",ic1h, irm1h, rms1h));
	disp(sprintf("IR1i impulse center : %d, max: %f, RMS: %f",ic1i, irm1i, rms1i));	
	disp(sprintf("IR1j impulse center : %d, max: %f, RMS: %f",ic1j, irm1j, rms1j));	
	
	disp(sprintf("IR2 impulse center : %d, max: %f, RMS: %f",ic2, irm2, rms2));
	disp(sprintf("IR2b impulse center : %d, max: %f, RMS: %f",ic2b, irm2b, rms2b));	
	disp(sprintf("IR2c impulse center : %d, max: %f, RMS: %f",ic2c, irm2c, rms2c));
	disp(sprintf("IR2d impulse center : %d, max: %f, RMS: %f",ic2d, irm2d, rms2d));
	disp(sprintf("IR2e impulse center : %d, max: %f, RMS: %f",ic2e, irm2e, rms2e));
	disp(sprintf("IR2f impulse center : %d, max: %f, RMS: %f",ic2f, irm2f, rms2f));	
	disp(sprintf("IR2g impulse center : %d, max: %f, RMS: %f",ic2g, irm2g, rms2g));
	disp(sprintf("IR2h impulse center : %d, max: %f, RMS: %f",ic2h, irm2h, rms2h));
	disp(sprintf("IR2i impulse center : %d, max: %f, RMS: %f",ic2i, irm2i, rms2i));	
	disp(sprintf("IR2j impulse center : %d, max: %f, RMS: %f",ic2j, irm2j, rms2j));

	disp(sprintf("IR3 impulse center : %d, max: %f, RMS: %f",ic3, irm3, rms3));
	disp(sprintf("IR3b impulse center : %d, max: %f, RMS: %f",ic3b, irm3b, rms3b));	
	disp(sprintf("IR3c impulse center : %d, max: %f, RMS: %f",ic3c, irm3c, rms3c));
	disp(sprintf("IR3d impulse center : %d, max: %f, RMS: %f",ic3d, irm3d, rms3d));
	disp(sprintf("IR3e impulse center : %d, max: %f, RMS: %f",ic3e, irm3e, rms3e));
	disp(sprintf("IR3f impulse center : %d, max: %f, RMS: %f",ic3f, irm3f, rms3f));	
	disp(sprintf("IR3g impulse center : %d, max: %f, RMS: %f",ic3g, irm3g, rms3g));
	disp(sprintf("IR3h impulse center : %d, max: %f, RMS: %f",ic3h, irm3h, rms3h));
	disp(sprintf("IR3i impulse center : %d, max: %f, RMS: %f",ic3i, irm3i, rms3i));	
	disp(sprintf("IR3j impulse center : %d, max: %f, RMS: %f",ic3j, irm3j, rms3j));
	
	fflush(stdout);
	
	
##############################################################################	
	# Report the stage
	disp("Mic correction...");
	fflush(stdout);	
	

	disp(mic);
	xp=mic(:,1);
	yp=mic(:,2);
	
	ixl = 20;
	ixu = 20000;
	xf = [ixl:ixu];
	
	mic1 = interp1(xp, yp, xf, "pchip");
	ixg= [1:ixu-ixl];
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,1,1);
	hold("on");
	
	# Plot the magnitude response 1
	subplot(1,1,1);
	semilogx(0.001*(ixg+19), mic1(ixg),["3;" it1 ";"],"LineWidth",DLW);
	#semilogx(0.001 * fs * ixg / 480, mic1(1000*ixg),["3;" it1 ";"],"LineWidth",DLW);
	
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,13,16,20]);
	title("Microphone response");	
		
	# Save the axis range
	g1ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -20;
	gax(4) = 10;
	
	# Set the uniform axis range
	subplot(1,1,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Disable holding the plot and set graph parameters
	subplot(1,1,1);
	hold("off");
		
	# Print to the output file
	print([ outdir fprefix "-mic" fext ],fdevice);	

	
			
##############################################################################
	# Report the stage
	disp("Various gating times...");
	fflush(stdout);
	
	# Windows array, in ms
	wlst = [100 30 10 3 1];
	
	# Graph resolution
	gres = 16384;
	
	# Graph pregap
	gpgp = 480;
	
	# Scaling base (dB)
	scbs = 14;
	
	# Scaling delta (dB)
	scdt = -6;
	
	# Compute the index limits
	ixl = floor(2 * 20 * gres / fs);
	ixu = ceil(2 * 20000 * gres / fs);
		
	# Open a new plot	
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,3,1);
	hold("on");
	subplot(1,3,2);
	hold("on");
	subplot(1,3,3);
	hold("on");
	
	# Cycle on the windows sizes
	cscl = scbs;
	cg = 1;
	for cws = wlst
		# Computes the number of samples for the current window
		wns = round(fs * cws / (2 * 1000));
		
		# Creates the response prewindow
		wind = [ones(1,gpgp) ones(1,wns) (blackman(2 * wns)((wns + 1):(2 * wns)))' zeros(1,gres - (gpgp + 2 * wns))]';
		
		# Extract the windowed impulse responses
		ir1w = ir1([(ic1 - gpgp):(ic1 + (gres - (gpgp + 1)))]) .* wind;
		ir1wb = ir1b([(ic1b - gpgp):(ic1b + (gres - (gpgp + 1)))]) .* wind;		
		ir1wc = ir1c([(ic1c - gpgp):(ic1c + (gres - (gpgp + 1)))]) .* wind;		
		ir1wd = ir1d([(ic1d - gpgp):(ic1d + (gres - (gpgp + 1)))]) .* wind;		
		ir1we = ir1e([(ic1e - gpgp):(ic1e + (gres - (gpgp + 1)))]) .* wind;
		ir1wf = ir1f([(ic1f - gpgp):(ic1f + (gres - (gpgp + 1)))]) .* wind;
		ir1wg = ir1g([(ic1g - gpgp):(ic1g + (gres - (gpgp + 1)))]) .* wind;		
		ir1wh = ir1h([(ic1h - gpgp):(ic1h + (gres - (gpgp + 1)))]) .* wind;		
		ir1wi = ir1i([(ic1i - gpgp):(ic1i + (gres - (gpgp + 1)))]) .* wind;		
		ir1wj = ir1j([(ic1j - gpgp):(ic1j + (gres - (gpgp + 1)))]) .* wind;

		
		ir2w = ir2([(ic2 - gpgp):(ic2 + (gres - (gpgp + 1)))]) .* wind;
		ir2wb = ir2b([(ic2b - gpgp):(ic2b + (gres - (gpgp + 1)))]) .* wind;
		ir2wc = ir2c([(ic2c - gpgp):(ic2c + (gres - (gpgp + 1)))]) .* wind;
		ir2wd = ir2d([(ic2d - gpgp):(ic2d + (gres - (gpgp + 1)))]) .* wind;
		ir2we = ir2e([(ic2e - gpgp):(ic2e + (gres - (gpgp + 1)))]) .* wind;
		ir2wf = ir2f([(ic2f - gpgp):(ic2f + (gres - (gpgp + 1)))]) .* wind;
		ir2wg = ir2g([(ic2g - gpgp):(ic2g + (gres - (gpgp + 1)))]) .* wind;		
		ir2wh = ir2h([(ic2h - gpgp):(ic2h + (gres - (gpgp + 1)))]) .* wind;		
		ir2wi = ir2i([(ic2i - gpgp):(ic2i + (gres - (gpgp + 1)))]) .* wind;		
		ir2wj = ir2j([(ic2j - gpgp):(ic2j + (gres - (gpgp + 1)))]) .* wind;
		
		ir3w = ir3([(ic3 - gpgp):(ic3 + (gres - (gpgp + 1)))]) .* wind;
		ir3wb = ir3b([(ic3b - gpgp):(ic3b + (gres - (gpgp + 1)))]) .* wind;
		ir3wc = ir3c([(ic3c - gpgp):(ic3c + (gres - (gpgp + 1)))]) .* wind;
		ir3wd = ir3d([(ic3d - gpgp):(ic3d + (gres - (gpgp + 1)))]) .* wind;
		ir3we = ir3e([(ic3e - gpgp):(ic3e + (gres - (gpgp + 1)))]) .* wind;
		ir3wf = ir3f([(ic3f - gpgp):(ic3f + (gres - (gpgp + 1)))]) .* wind;
		ir3wg = ir3g([(ic3g - gpgp):(ic3g + (gres - (gpgp + 1)))]) .* wind;		
		ir3wh = ir3h([(ic3h - gpgp):(ic3h + (gres - (gpgp + 1)))]) .* wind;		
		ir3wi = ir3i([(ic3i - gpgp):(ic3i + (gres - (gpgp + 1)))]) .* wind;		
		ir3wj = ir3j([(ic3j - gpgp):(ic3j + (gres - (gpgp + 1)))]) .* wind;		

		# Computes the smoothed magnitude response
		ir1m = ssev(ir1w,fs,0.15,1);
		ir1mb = ssev(ir1wb,fs,0.15,1);		
		ir1mc = ssev(ir1wc,fs,0.15,1);		
		ir1md = ssev(ir1wd,fs,0.15,1);		
		ir1me = ssev(ir1we,fs,0.15,1);	
		ir1mf = ssev(ir1wf,fs,0.15,1);
		ir1mg = ssev(ir1wg,fs,0.15,1);		
		ir1mh = ssev(ir1wh,fs,0.15,1);		
		ir1mi = ssev(ir1wi,fs,0.15,1);		
		ir1mj = ssev(ir1wj,fs,0.15,1);
		
		ir2m = ssev(ir2w,fs,0.15,1);		
		ir2mb = ssev(ir2wb,fs,0.15,1);
		ir2mc = ssev(ir2wc,fs,0.15,1);		
		ir2md = ssev(ir2wd,fs,0.15,1);		
		ir2me = ssev(ir2we,fs,0.15,1);	
		ir2mf = ssev(ir2wf,fs,0.15,1);
		ir2mg = ssev(ir2wg,fs,0.15,1);		
		ir2mh = ssev(ir2wh,fs,0.15,1);		
		ir2mi = ssev(ir2wi,fs,0.15,1);		
		ir2mj = ssev(ir2wj,fs,0.15,1);	
			
		ir3m = ssev(ir3w,fs,0.15,1);		
		ir3mb = ssev(ir3wb,fs,0.15,1);
		ir3mc = ssev(ir3wc,fs,0.15,1);		
		ir3md = ssev(ir3wd,fs,0.15,1);		
		ir3me = ssev(ir3we,fs,0.15,1);	
		ir3mf = ssev(ir3wf,fs,0.15,1);
		ir3mg = ssev(ir3wg,fs,0.15,1);		
		ir3mh = ssev(ir3wh,fs,0.15,1);		
		ir3mi = ssev(ir3wi,fs,0.15,1);		
		ir3mj = ssev(ir3wj,fs,0.15,1);			
		
		% # Computes the graph lower bounds
		glb = fs / (0.7 * wns);
		glb = round(glb / (fs / (2 * gres)));
		glb = max(glb,2);
		
		# Computes the graph index
		ixg = max(ixl,glb):ixu;
				
		# Plot the magnitude response
		subplot(1,3,1);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + 20 * (log10(ir1m(1 + ixg))+log10(ir1mb(1 + ixg))+log10(ir1mc(1 + ixg))+log10(ir1md(1 + ixg))+log10(ir1me(1 + ixg))+log10(ir1mf(1 + ixg))+log10(ir1mg(1 + ixg))+log10(ir1mh(1 + ixg))+log10(ir1mi(1 + ixg))+log10(ir1mj(1 + ixg)))/10,"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
		subplot(1,3,2);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + 20 * (log10(ir2m(1 + ixg))+log10(ir2mb(1 + ixg))+log10(ir2mc(1 + ixg))+log10(ir2md(1 + ixg))+log10(ir2me(1 + ixg))+log10(ir2mf(1 + ixg))+log10(ir2mg(1 + ixg))+log10(ir2mh(1 + ixg))+log10(ir2mi(1 + ixg))+log10(ir2mj(1 + ixg)))/10,"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
			
		subplot(1,3,3);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + 20 * (log10(ir3m(1 + ixg))+log10(ir3mb(1 + ixg))+log10(ir3mc(1 + ixg))+log10(ir3md(1 + ixg))+log10(ir3me(1 + ixg))+log10(ir3mf(1 + ixg))+log10(ir3mg(1 + ixg))+log10(ir3mh(1 + ixg))+log10(ir3mi(1 + ixg))+log10(ir3mj(1 + ixg)))/10,"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
				
		# Adjust the scaling
		cscl = cscl + scdt;
		cg = cg + 1;
	endfor	
	
	subplot(1,3,1);
	hold("off");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(it1);	

	subplot(1,3,2);
	hold("off");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title([it2 " Mean frequency response, 1-3-10-30-100 ms gatings"]);
	
	subplot(1,3,3);
	hold("off");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(it3);	
	
	
	# Save the axis range
	subplot(1,3,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,3,2);
	axis([0.02, 20]);	
	g2ax = axis();
	subplot(1,3,3);
	axis([0.02, 20]);	
	g3ax = axis();

	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -20;
	gax(4) = 34;
	
	
	# Set the uniform axis range
	subplot(1,3,1);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	subplot(1,3,2);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	subplot(1,3,3);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	
	# Print to the output file
	print([ outdir fprefix "-Multiple-Various-gatings" fext ],fdevice);

	# Remove variables no longer used
	clear wind ir1w ir1m ir2w ir2m ixl ixu ixg g1ax g2ax g3ax gax;
	
	
	
##############################################################################		
# Report the stage
	disp("Mean psychoacoustic response...");
	fflush(stdout);
	
	# Extract the windowed impulse responses
	ir1w = ir1(ic1-32767:ic1+32768);
	ir1wb = ir1b(ic1b-32767:ic1b+32768);	
	ir1wc = ir1c(ic1c-32767:ic1c+32768);	
	ir1wd = ir1d(ic1d-32767:ic1d+32768);	
	ir1we = ir1e(ic1e-32767:ic1e+32768);	
	ir1wf = ir1f(ic1f-32767:ic1f+32768);	
	ir1wg = ir1g(ic1g-32767:ic1g+32768);	
	ir1wh = ir1h(ic1h-32767:ic1h+32768);	
	ir1wi = ir1i(ic1i-32767:ic1i+32768);	
	ir1wj = ir1j(ic1j-32767:ic1j+32768);		
	
	ir2w = ir2(ic2-32767:ic2+32768);
	ir2wb = ir2b(ic2b-32767:ic2b+32768);
	ir2wc = ir2c(ic2c-32767:ic2c+32768);
	ir2wd = ir2d(ic2d-32767:ic2d+32768);
	ir2we = ir2e(ic2e-32767:ic2e+32768);
	ir2wf = ir2f(ic2f-32767:ic2f+32768);	
	ir2wg = ir2g(ic2g-32767:ic2g+32768);	
	ir2wh = ir2h(ic2h-32767:ic2h+32768);	
	ir2wi = ir2i(ic2i-32767:ic2i+32768);	
	ir2wj = ir2j(ic2j-32767:ic2j+32768);
	
	ir3w = ir3(ic3-32767:ic3+32768);
	ir3wb = ir3b(ic3b-32767:ic3b+32768);
	ir3wc = ir3c(ic3c-32767:ic3c+32768);
	ir3wd = ir3d(ic3d-32767:ic3d+32768);
	ir3we = ir3e(ic3e-32767:ic3e+32768);
	ir3wf = ir3f(ic3f-32767:ic3f+32768);	
	ir3wg = ir3g(ic3g-32767:ic3g+32768);	
	ir3wh = ir3h(ic3h-32767:ic3h+32768);	
	ir3wi = ir3i(ic3i-32767:ic3i+32768);	
	ir3wj = ir3j(ic3j-32767:ic3j+32768);	
	
	# Extract the minimum phase impulse response, w3 is for long gating
	[ir1cps, ir1w3] = rceps(ir1w);
	[ir1cps, ir1w3b] = rceps(ir1wb);	
	[ir1cps, ir1w3c] = rceps(ir1wc);	
	[ir1cps, ir1w3d] = rceps(ir1wd);
	[ir1cps, ir1w3e] = rceps(ir1we);
	[ir1cps, ir1w3f] = rceps(ir1wf);	
	[ir1cps, ir1w3g] = rceps(ir1wg);	
	[ir1cps, ir1w3h] = rceps(ir1wh);
	[ir1cps, ir1w3i] = rceps(ir1wi);
	[ir1cps, ir1w3j] = rceps(ir1wj);
	
	[ir2cps, ir2w3] = rceps(ir2w);
	[ir2cps, ir2w3b] = rceps(ir2wb);
	[ir2cps, ir2w3c] = rceps(ir2wc);
	[ir2cps, ir2w3d] = rceps(ir2wd);
	[ir2cps, ir2w3e] = rceps(ir2we);
	[ir2cps, ir2w3f] = rceps(ir2wf);	
	[ir2cps, ir2w3g] = rceps(ir2wg);	
	[ir2cps, ir2w3h] = rceps(ir2wh);
	[ir2cps, ir2w3i] = rceps(ir2wi);
	[ir2cps, ir2w3j] = rceps(ir2wj);
	
	[ir3cps, ir3w3] = rceps(ir3w);
	[ir3cps, ir3w3b] = rceps(ir3wb);
	[ir3cps, ir3w3c] = rceps(ir3wc);
	[ir3cps, ir3w3d] = rceps(ir3wd);
	[ir3cps, ir3w3e] = rceps(ir3we);
	[ir3cps, ir3w3f] = rceps(ir3wf);	
	[ir3cps, ir3w3g] = rceps(ir3wg);	
	[ir3cps, ir3w3h] = rceps(ir3wh);
	[ir3cps, ir3w3i] = rceps(ir3wi);
	[ir3cps, ir3w3j] = rceps(ir3wj);
			
	clear ir1cps ir2cps ir3cps;		

	# Performs the frequency dependant windowing, w1 is for psycho, w2 is for FDW 10 periods
	ir1w1 = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2 = irslprefilt(ir1w,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1b = irslprefilt(ir1wb,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2b = irslprefilt(ir1wb,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1c = irslprefilt(ir1wc,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2c = irslprefilt(ir1wc,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1d = irslprefilt(ir1wd,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2d = irslprefilt(ir1wd,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1e = irslprefilt(ir1we,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2e = irslprefilt(ir1we,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1f = irslprefilt(ir1wf,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2f = irslprefilt(ir1wf,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1g = irslprefilt(ir1wg,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2g = irslprefilt(ir1wg,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1h = irslprefilt(ir1wh,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2h = irslprefilt(ir1wh,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1i = irslprefilt(ir1wi,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2i = irslprefilt(ir1wi,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir1w1j = irslprefilt(ir1wj,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir1w2j = irslprefilt(ir1wj,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);

	ir2w1 = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2 = irslprefilt(ir2w,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1b = irslprefilt(ir2wb,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2b = irslprefilt(ir2wb,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir2w1c = irslprefilt(ir2wc,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2c = irslprefilt(ir2wc,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1d = irslprefilt(ir2wd,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2d = irslprefilt(ir2wd,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir2w1e = irslprefilt(ir2we,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2e = irslprefilt(ir2we,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir2w1f = irslprefilt(ir2wf,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2f = irslprefilt(ir2wf,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1g = irslprefilt(ir2wg,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2g = irslprefilt(ir2wg,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1h = irslprefilt(ir2wh,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2h = irslprefilt(ir2wh,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1i = irslprefilt(ir2wi,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2i = irslprefilt(ir2wi,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir2w1j = irslprefilt(ir2wj,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir2w2j = irslprefilt(ir2wj,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);

	ir3w1 = irslprefilt(ir3w,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2 = irslprefilt(ir3w,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1b = irslprefilt(ir3wb,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2b = irslprefilt(ir3wb,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir3w1c = irslprefilt(ir3wc,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2c = irslprefilt(ir3wc,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1d = irslprefilt(ir3wd,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2d = irslprefilt(ir3wd,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir3w1e = irslprefilt(ir3we,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2e = irslprefilt(ir3we,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);	
	ir3w1f = irslprefilt(ir3wf,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2f = irslprefilt(ir3wf,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1g = irslprefilt(ir3wg,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2g = irslprefilt(ir3wg,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1h = irslprefilt(ir3wh,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2h = irslprefilt(ir3wh,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1i = irslprefilt(ir3wi,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2i = irslprefilt(ir3wi,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	ir3w1j = irslprefilt(ir3wj,32758,2 * 20/fs,floor(fs*LFW/1000),2 * 20000/fs,floor(fs*HFW/1000),WEG,4096,1.0,10,0);
	ir3w2j = irslprefilt(ir3wj,32758,2 * 20/fs,floor(fs*10/20),2 * 20000/fs,floor(fs*10/20000),1,4096,1.0,10,0);
	
	# Pad the windowed impulse response
	ir1w1 = [ zeros(1,65536 - length(ir1w1)) ir1w1(:)' ];
	ir1w2 = [ zeros(1,65536 - length(ir1w2)) ir1w2(:)' ];	
	ir1w1b = [ zeros(1,65536 - length(ir1w1b)) ir1w1b(:)' ];	
	ir1w2b = [ zeros(1,65536 - length(ir1w2b)) ir1w2b(:)' ];	
	ir1w1c = [ zeros(1,65536 - length(ir1w1c)) ir1w1c(:)' ];	
	ir1w2c = [ zeros(1,65536 - length(ir1w2c)) ir1w2c(:)' ];	
	ir1w1d = [ zeros(1,65536 - length(ir1w1d)) ir1w1d(:)' ];	
	ir1w2d = [ zeros(1,65536 - length(ir1w2d)) ir1w2d(:)' ];	
	ir1w1e = [ zeros(1,65536 - length(ir1w1e)) ir1w1e(:)' ];	
	ir1w2e = [ zeros(1,65536 - length(ir1w2e)) ir1w2e(:)' ];
	ir1w1f = [ zeros(1,65536 - length(ir1w1f)) ir1w1f(:)' ];	
	ir1w2f = [ zeros(1,65536 - length(ir1w2f)) ir1w2f(:)' ];	
	ir1w1g = [ zeros(1,65536 - length(ir1w1g)) ir1w1g(:)' ];	
	ir1w2g = [ zeros(1,65536 - length(ir1w2g)) ir1w2g(:)' ];	
	ir1w1h = [ zeros(1,65536 - length(ir1w1h)) ir1w1h(:)' ];	
	ir1w2h = [ zeros(1,65536 - length(ir1w2h)) ir1w2h(:)' ];	
	ir1w1i = [ zeros(1,65536 - length(ir1w1i)) ir1w1i(:)' ];	
	ir1w2i = [ zeros(1,65536 - length(ir1w2i)) ir1w2i(:)' ];
	ir1w1j = [ zeros(1,65536 - length(ir1w1j)) ir1w1j(:)' ];	
	ir1w2j = [ zeros(1,65536 - length(ir1w2j)) ir1w2j(:)' ];
	
	ir2w1 = [ zeros(1,65536 - length(ir2w1)) ir2w1(:)' ];
	ir2w2 = [ zeros(1,65536 - length(ir2w2)) ir2w2(:)' ];
	ir2w1b = [ zeros(1,65536 - length(ir2w1b)) ir2w1b(:)' ];
	ir2w2b = [ zeros(1,65536 - length(ir2w2b)) ir2w2b(:)' ];	
	ir2w1c = [ zeros(1,65536 - length(ir2w1c)) ir2w1c(:)' ];
	ir2w2c = [ zeros(1,65536 - length(ir2w2c)) ir2w2c(:)' ];	
	ir2w1d = [ zeros(1,65536 - length(ir2w1d)) ir2w1d(:)' ];
	ir2w2d = [ zeros(1,65536 - length(ir2w2d)) ir2w2d(:)' ];	
	ir2w1e = [ zeros(1,65536 - length(ir2w1e)) ir2w1e(:)' ];
	ir2w2e = [ zeros(1,65536 - length(ir2w2e)) ir2w2e(:)' ];	
	ir2w1f = [ zeros(1,65536 - length(ir2w1f)) ir2w1f(:)' ];	
	ir2w2f = [ zeros(1,65536 - length(ir2w2f)) ir2w2f(:)' ];	
	ir2w1g = [ zeros(1,65536 - length(ir2w1g)) ir2w1g(:)' ];	
	ir2w2g = [ zeros(1,65536 - length(ir2w2g)) ir2w2g(:)' ];	
	ir2w1h = [ zeros(1,65536 - length(ir2w1h)) ir2w1h(:)' ];	
	ir2w2h = [ zeros(1,65536 - length(ir2w2h)) ir2w2h(:)' ];	
	ir2w1i = [ zeros(1,65536 - length(ir2w1i)) ir2w1i(:)' ];	
	ir2w2i = [ zeros(1,65536 - length(ir2w2i)) ir2w2i(:)' ];
	ir2w1j = [ zeros(1,65536 - length(ir2w1j)) ir2w1j(:)' ];	
	ir2w2j = [ zeros(1,65536 - length(ir2w2j)) ir2w2j(:)' ];		
	
	ir3w1 = [ zeros(1,65536 - length(ir3w1)) ir3w1(:)' ];
	ir3w2 = [ zeros(1,65536 - length(ir3w2)) ir3w2(:)' ];
	ir3w1b = [ zeros(1,65536 - length(ir3w1b)) ir3w1b(:)' ];
	ir3w2b = [ zeros(1,65536 - length(ir3w2b)) ir3w2b(:)' ];	
	ir3w1c = [ zeros(1,65536 - length(ir3w1c)) ir3w1c(:)' ];
	ir3w2c = [ zeros(1,65536 - length(ir3w2c)) ir3w2c(:)' ];	
	ir3w1d = [ zeros(1,65536 - length(ir3w1d)) ir3w1d(:)' ];
	ir3w2d = [ zeros(1,65536 - length(ir3w2d)) ir3w2d(:)' ];	
	ir3w1e = [ zeros(1,65536 - length(ir3w1e)) ir3w1e(:)' ];
	ir3w2e = [ zeros(1,65536 - length(ir3w2e)) ir3w2e(:)' ];	
	ir3w1f = [ zeros(1,65536 - length(ir3w1f)) ir3w1f(:)' ];	
	ir3w2f = [ zeros(1,65536 - length(ir3w2f)) ir3w2f(:)' ];	
	ir3w1g = [ zeros(1,65536 - length(ir3w1g)) ir3w1g(:)' ];	
	ir3w2g = [ zeros(1,65536 - length(ir3w2g)) ir3w2g(:)' ];	
	ir3w1h = [ zeros(1,65536 - length(ir3w1h)) ir3w1h(:)' ];	
	ir3w2h = [ zeros(1,65536 - length(ir3w2h)) ir3w2h(:)' ];	
	ir3w1i = [ zeros(1,65536 - length(ir3w1i)) ir3w1i(:)' ];	
	ir3w2i = [ zeros(1,65536 - length(ir3w2i)) ir3w2i(:)' ];
	ir3w1j = [ zeros(1,65536 - length(ir3w1j)) ir3w1j(:)' ];	
	ir3w2j = [ zeros(1,65536 - length(ir3w2j)) ir3w2j(:)' ];	
	
	# Computes the smoothed magnitude response
	ir1m1 = (ssev(ir1w1,fs,smoothtype,SE,'prepeak')+ssev(ir1w1b,fs,smoothtype,SE,'prepeak')+ssev(ir1w1c,fs,smoothtype,SE,'prepeak')+ssev(ir1w1d,fs,smoothtype,SE,'prepeak')+ssev(ir1w1e,fs,smoothtype,SE,'prepeak')+ssev(ir1w1f,fs,smoothtype,SE,'prepeak')+ssev(ir1w1g,fs,smoothtype,SE,'prepeak')+ssev(ir1w1h,fs,smoothtype,SE,'prepeak')+ssev(ir1w1i,fs,smoothtype,SE,'prepeak')+ssev(ir1w1j,fs,smoothtype,SE,'prepeak')-min(ssev(ir1w1,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1b,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1c,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1d,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1e,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1f,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1g,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1h,fs,smoothtype,SE,'prepeak'),min(ssev(ir1w1i,fs,smoothtype,SE,'prepeak'),ssev(ir1w1j,fs,smoothtype,SE,'prepeak')))))))))))/10;
	ir1m2 = (ssev(ir1w2,fs,0.1,1)+ ssev(ir1w2b,fs,0.1,1)+ssev(ir1w2c,fs,0.1,1)+ssev(ir1w2d,fs,0.1,1)+ssev(ir1w2e,fs,0.1,1)+ssev(ir1w2f,fs,0.1,1)+ ssev(ir1w2g,fs,0.1,1)+ssev(ir1w2h,fs,0.1,1)+ssev(ir1w2i,fs,0.1,1)+ssev(ir1w2j,fs,0.1,1))/10;	
	ir1m3 = (ssev(ir1w3,fs,0.33,1)+ ssev(ir1w3b,fs,0.33,1)+ssev(ir1w3c,fs,0.33,1)+ssev(ir1w3d,fs,0.33,1)+ssev(ir1w3e,fs,0.33,1)+ssev(ir1w3f,fs,0.33,1)+ ssev(ir1w3g,fs,0.33,1)+ssev(ir1w3h,fs,0.33,1)+ssev(ir1w3i,fs,0.33,1)+ssev(ir1w3j,fs,0.33,1))/10;	

	ir2m1 = (ssev(ir2w1,fs,smoothtype,SE,'prepeak')+ssev(ir2w1b,fs,smoothtype,SE,'prepeak')+ssev(ir2w1c,fs,smoothtype,SE,'prepeak')+ssev(ir2w1d,fs,smoothtype,SE,'prepeak')+ssev(ir2w1e,fs,smoothtype,SE,'prepeak')+ssev(ir2w1f,fs,smoothtype,SE,'prepeak')+ssev(ir2w1g,fs,smoothtype,SE,'prepeak')+ssev(ir2w1h,fs,smoothtype,SE,'prepeak')+ssev(ir2w1i,fs,smoothtype,SE,'prepeak')+ssev(ir2w1j,fs,smoothtype,SE,'prepeak')-min(ssev(ir2w1,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1b,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1c,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1d,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1e,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1f,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1g,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1h,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1i,fs,smoothtype,SE,'prepeak'),ssev(ir2w1j,fs,smoothtype,SE,'prepeak')))))))))))/10;
	ir2m2 = (ssev(ir2w2,fs,0.1,1)+ ssev(ir2w2b,fs,0.1,1)+ssev(ir2w2c,fs,0.1,1)+ssev(ir2w2d,fs,0.1,1)+ssev(ir2w2e,fs,0.1,1)+ssev(ir2w2f,fs,0.1,1)+ ssev(ir2w2g,fs,0.1,1)+ssev(ir2w2h,fs,0.1,1)+ssev(ir2w2i,fs,0.1,1)+ssev(ir2w2j,fs,0.1,1))/10;	
	ir2m3 = (ssev(ir2w3,fs,0.33,1)+ ssev(ir2w3b,fs,0.33,1)+ssev(ir2w3c,fs,0.33,1)+ssev(ir2w3d,fs,0.33,1)+ssev(ir2w3e,fs,0.33,1)+ssev(ir2w3f,fs,0.33,1)+ ssev(ir2w3g,fs,0.33,1)+ssev(ir2w3h,fs,0.33,1)+ssev(ir2w3i,fs,0.33,1)+ssev(ir2w3j,fs,0.33,1))/10;
		
	ir3m1 = (ssev(ir3w1,fs,smoothtype,SE,'prepeak')+ssev(ir3w1b,fs,smoothtype,SE,'prepeak')+ssev(ir3w1c,fs,smoothtype,SE,'prepeak')+ssev(ir3w1d,fs,smoothtype,SE,'prepeak')+ssev(ir3w1e,fs,smoothtype,SE,'prepeak')+ssev(ir3w1f,fs,smoothtype,SE,'prepeak')+ssev(ir3w1g,fs,smoothtype,SE,'prepeak')+ssev(ir3w1h,fs,smoothtype,SE,'prepeak')+ssev(ir3w1i,fs,smoothtype,SE,'prepeak')+ssev(ir3w1j,fs,smoothtype,SE,'prepeak')-min(ssev(ir3w1,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1b,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1c,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1d,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1e,fs,smoothtype,SE,'prepeak'),min(ssev(ir2w1f,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1g,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1h,fs,smoothtype,SE,'prepeak'),min(ssev(ir3w1i,fs,smoothtype,SE,'prepeak'),ssev(ir3w1j,fs,smoothtype,SE,'prepeak')))))))))))/10;
	ir3m2 = (ssev(ir3w2,fs,0.1,1)+ ssev(ir3w2b,fs,0.1,1)+ssev(ir3w2c,fs,0.1,1)+ssev(ir3w2d,fs,0.1,1)+ssev(ir3w2e,fs,0.1,1)+ssev(ir3w2f,fs,0.1,1)+ ssev(ir3w2g,fs,0.1,1)+ssev(ir3w2h,fs,0.1,1)+ssev(ir3w2i,fs,0.1,1)+ssev(ir3w2j,fs,0.1,1))/10;	
	ir3m3 = (ssev(ir3w3,fs,0.33,1)+ ssev(ir3w3b,fs,0.33,1)+ssev(ir3w3c,fs,0.33,1)+ssev(ir3w3d,fs,0.33,1)+ssev(ir3w3e,fs,0.33,1)+ssev(ir3w3f,fs,0.33,1)+ ssev(ir3w3g,fs,0.33,1)+ssev(ir3w3h,fs,0.33,1)+ssev(ir3w3i,fs,0.33,1)+ssev(ir3w3j,fs,0.33,1))/10;
	
	# average the response nr2 to 0dB but keep delta of responses	
	ix2m = mean(ir1m2(fs/200:fs/20));
	ir1m1 = ir1m1/ix2m;
	ir1m2 = ir1m2/ix2m;
	ir1m3 = ir1m3/ix2m;	
	ir2m1 = ir2m1/ix2m;
	ir2m2 = ir2m2/ix2m;	
	ir2m3 = ir2m3/ix2m;	
	ir3m1 = ir3m1/ix2m;
	ir3m2 = ir3m2/ix2m;	
	ir3m3 = ir3m3/ix2m;		
	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,3,1);
	hold("on");
	subplot(1,3,2);
	hold("on");
	subplot(1,3,3);
	hold("on");	
	
	# Compute the index limits
	ixl = floor(20 * length(ir1m1) / fs);
	ixu = ceil(20000 *2* length(ir1m1) / fs);
	ixg = ixl:ixu;
		
	subplot(1,3,1);
	semilogx(0.0005 * fs * ixg / length(ir1m1),20 * log10(ir1m1(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" it1 " psycho" ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	grid("on");

	subplot(1,3,2);
	semilogx(0.0005 * fs * ixg / length(ir2m1),20 * log10(ir2m1(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" it2 ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	title("Mean psychoacoustic frequency response");	

	subplot(1,3,3);
	semilogx(0.0005 * fs * ixg / length(ir3m1),20 * log10(ir3m1(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" it3 ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	title(["Parameters" sprintf(" %.0f-%.0fms, WE %.1f, smooth %.2f, SE %.0f",HFW, LFW, WEG, smoothtype,SE) ""])	

	# Compute the index limits
	ixl = floor(20 * length(ir1m2) / fs);
	ixu = ceil(20000 *2* length(ir1m2) / fs);
	ixg = ixl:ixu;
	
	# Plot the magnitude response
	subplot(1,3,1);
	semilogx(0.0005 * fs * ixg / length(ir1m2),20 * log10(ir1m2(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["2;" ";"],"LineWidth",DLW);	

	subplot(1,3,2);
	semilogx(0.0005 * fs * ixg / length(ir2m2),20 * log10(ir2m2(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["2;" "FDW 10 periods" ";"],"LineWidth",DLW);
	
	subplot(1,3,3);
	semilogx(0.0005 * fs * ixg / length(ir3m2),20 * log10(ir3m2(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["2;" ";"],"LineWidth",DLW);	

	
			
	# Disable holding the plot and set graph parameters
	subplot(1,3,1);
	hold("off");
	subplot(1,3,2);
	hold("off");
	subplot(1,3,3);
	hold("off");
	
	# Save the axis range
	subplot(1,3,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,3,2);
	axis([0.02, 20]);	
	g2ax = axis();
	subplot(1,3,3);
	axis([0.02, 20]);	
	g2ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 12;
		
	# Set the uniform axis range
	subplot(1,3,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,3,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,3,3);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Print to the output file
	print([ outdir fprefix "-Multiple-psychoacoustic" fext ],fdevice);
	
	
	##############################################################################		
# Report the stage
	disp("Mean 1/3 octave...");
		
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,3,1);
	hold("on");
	subplot(1,3,2);
	hold("on");
	subplot(1,3,3);
	hold("on");	
	
	# Compute the index limits
	ixl = floor(20 * length(ir1m1) / fs);
	ixu = ceil(20000 *2* length(ir1m1) / fs);
	ixg = ixl:ixu;
		
		
	subplot(1,3,1);
	semilogx(0.0005 * fs * ixg / length(ir1m3),20 * log10(ir1m3(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" ";"],"LineWidth",DLW);
	
	if (limits == 1)
	disp ('AES-EBU');
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),min(-3,0.8-3*log10(0.01 * fs * ixg / length(ir1w))),["2;" "AES-EBU limits" ";"],"LineWidth",DLW);

	elseif (limits == 2)
	disp ('BK');
	semilogx(0.001 * fs * ixg / length(ir1w),min(1.5,2-2*log10(0.01 * fs * ixg / length(ir1w))),["2;" "BK target" ";"],"LineWidth",DLW);
		
	elseif (limits == 3)
	disp ('SMPTE small room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(12-7*log10(0.01 * fs * ixg / length(ir1w)),min(38-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(6-7*log10(0.01 * fs * ixg / length(ir1w)),min(32-20*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE small room" ";"],"LineWidth",DLW);
		
	elseif (limits == 4)
	disp ('SMPTE mid room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(16-10*log10(0.01 * fs * ixg / length(ir1w)),min(36-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(10-10*log10(0.01 * fs * ixg / length(ir1w)),min(48-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE medium room" ";"],"LineWidth",DLW);
	
	elseif (limits == 5)
	disp ('SMPTE large room');	
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(22.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(57-30*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(16.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(45-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE large room" ";"],"LineWidth",DLW);
	
	elseif (limits == 6)
	disp ('Dolby X-curve');	
	semilogx(min(0.1,0.001 * fs * ixg / length(ir1w)),10*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(0,min(14.2-11*log10(0.01 * fs * ixg / length(ir1w)),2+7*log10(0.01 * fs * ixg / length(ir1w)))),["2;" "Dolby X-curve" ";"],"LineWidth",DLW);
			
	else
	disp ('custom');	
	semilogx(0.001 * fs * ixg / length(ir1w),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),-3*(1+ixg-ixg),["2;" "custom" ";"],"LineWidth",DLW);
	endif
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	grid("on");

	
	
	subplot(1,3,2);
	semilogx(0.0005 * fs * ixg / length(ir2m3),20 * log10(ir2m3(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" ";"],"LineWidth",DLW);
		
	if (limits == 1)
	disp ('AES-EBU');
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),min(-3,0.8-3*log10(0.01 * fs * ixg / length(ir1w))),["2;" "AES-EBU limits" ";"],"LineWidth",DLW);

	elseif (limits == 2)
	disp ('BK');
	semilogx(0.001 * fs * ixg / length(ir1w),min(1.5,2-2*log10(0.01 * fs * ixg / length(ir1w))),["2;" "BK target" ";"],"LineWidth",DLW);
		
	elseif (limits == 3)
	disp ('SMPTE small room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(12-7*log10(0.01 * fs * ixg / length(ir1w)),min(38-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(6-7*log10(0.01 * fs * ixg / length(ir1w)),min(32-20*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE small room" ";"],"LineWidth",DLW);
		
	elseif (limits == 4)
	disp ('SMPTE mid room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(16-10*log10(0.01 * fs * ixg / length(ir1w)),min(36-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(10-10*log10(0.01 * fs * ixg / length(ir1w)),min(48-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE medium room" ";"],"LineWidth",DLW);
	
	elseif (limits == 5)
	disp ('SMPTE large room');	
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(22.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(57-30*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(16.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(45-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE large room" ";"],"LineWidth",DLW);
	
	elseif (limits == 6)
	disp ('Dolby X-curve');	
	semilogx(min(0.1,0.001 * fs * ixg / length(ir1w)),10*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(0,min(14.2-11*log10(0.01 * fs * ixg / length(ir1w)),2+7*log10(0.01 * fs * ixg / length(ir1w)))),["2;" "Dolby X-curve" ";"],"LineWidth",DLW);
			
	else
	disp ('custom');	
	semilogx(0.001 * fs * ixg / length(ir1w),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),-3*(1+ixg-ixg),["2;" "custom" ";"],"LineWidth",DLW);
	endif
		
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	title("Mean 1/3 octave frequency response");	

	
	
	subplot(1,3,3);
	semilogx(0.0005 * fs * ixg / length(ir3m3),20 * log10(ir3m3(1 + ixg))-mic1(min(29980,round(1*(0.366*ixg-8)))),["3;" ";"],"LineWidth",DLW);
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	
	# Compute the index limits
	ixl = floor(20 * length(ir1m2) / fs);
	ixu = ceil(20000 *2* length(ir1m2) / fs);
	ixg = ixl:ixu;
	
	if (limits == 1)
	disp ('AES-EBU');
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(max(0.04,0.001 * fs * ixg / length(ir1w)),min(-3,0.8-3*log10(0.01 * fs * ixg / length(ir1w))),["2;" "AES-EBU limits" ";"],"LineWidth",DLW);

	elseif (limits == 2)
	disp ('BK');
	semilogx(0.001 * fs * ixg / length(ir1w),min(1.5,2-2*log10(0.01 * fs * ixg / length(ir1w))),["2;" "BK target" ";"],"LineWidth",DLW);
		
	elseif (limits == 3)
	disp ('SMPTE small room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(12-7*log10(0.01 * fs * ixg / length(ir1w)),min(38-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(6-7*log10(0.01 * fs * ixg / length(ir1w)),min(32-20*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE small room" ";"],"LineWidth",DLW);
		
	elseif (limits == 4)
	disp ('SMPTE mid room');
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(16-10*log10(0.01 * fs * ixg / length(ir1w)),min(36-20*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(10-10*log10(0.01 * fs * ixg / length(ir1w)),min(48-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE medium room" ";"],"LineWidth",DLW);
	
	elseif (limits == 5)
	disp ('SMPTE large room');	
	semilogx(0.001 * fs * ixg / length(ir1w),min(3,min(22.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(57-30*log10(0.01 * fs * ixg / length(ir1w)),5+7*log10(0.01 * fs * ixg / length(ir1w))))),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(-3,min(16.5-15*log10(0.01 * fs * ixg / length(ir1w)),min(45-30*log10(0.01 * fs * ixg / length(ir1w)),2+18*log10(0.01 * fs * ixg / length(ir1w))))),["2;" "SMPTE large room" ";"],"LineWidth",DLW);
	
	elseif (limits == 6)
	disp ('Dolby X-curve');	
	semilogx(min(0.1,0.001 * fs * ixg / length(ir1w)),10*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),min(0,min(14.2-11*log10(0.01 * fs * ixg / length(ir1w)),2+7*log10(0.01 * fs * ixg / length(ir1w)))),["2;" "Dolby X-curve" ";"],"LineWidth",DLW);
			
	else
	disp ('custom');	
	semilogx(0.001 * fs * ixg / length(ir1w),3*(1+ixg-ixg),["2;" ";"],"LineWidth",DLW);
	semilogx(0.001 * fs * ixg / length(ir1w),-3*(1+ixg-ixg),["2;" "custom" ";"],"LineWidth",DLW);
	endif
			
	# Disable holding the plot and set graph parameters
	subplot(1,3,1);
	hold("off");
	subplot(1,3,2);
	hold("off");
	subplot(1,3,3);
	hold("off");
	
	# Save the axis range
	subplot(1,3,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,3,2);
	axis([0.02, 20]);	
	g2ax = axis();
	subplot(1,3,3);
	axis([0.02, 20]);	
	g2ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -15;
	gax(4) = 12;
		
	# Set the uniform axis range
	subplot(1,3,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,3,2);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	subplot(1,3,3);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Print to the output file
	print([ outdir fprefix "-Multiple-1-3octave" fext ],fdevice);
	
	
	
	
	
	
	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);

endfunction