## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of DRC - Digital room correction

## usage: create2multiplots(ir1,ic1,it1,ir2,ic2,it2,outdir,fprefix,fext,fdevice)
##
##
##
## ir1 = impulse response 1
## ic1 = center sample of impulse response 1, -1 for automatic search
## it1 = title for impulse response 1 plots
## ir2 = impulse response 2
## ic2 = center sample of impulse response 2, -1 for automatic search
## it2 = title for impulse response 2 plots
## outdir = output directory for graph files
## fprefix = prefix for graph files
## fext = extension for graph files, default '.eps'
## fdevice = print device for graph files, default '-depsc'
##  
## script for Align2, by Jean-Luc Ohl
# psychoacoustic curve smoothtype = -2 for ERB, -1 for Bark, 0.33 for 1/3 octave, 0.15 for 1/6 octave,...


function createmeanfft(ir1,ic1,it1,ir2,ic2,it2,outdir,fprefix,fext = '.eps',fdevice = '-S640,480 -deps')



fs=48000;
fdevice = '-S1200,220';
limits = 1;
HFW = 3;
LFW = 300;
WEG = 1;
smoothtype = 0.08;
SE = 10;
mic = load('C:\Users\jlo\Desktop\align2\files\mic\kt-vert1.txt');


ir1b = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L2.wav1.pcm');
ir1c = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L4.wav1.pcm');
ir1d = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L6.wav1.pcm');
ir1e = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L7.wav1.pcm');
ir1f = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L8.wav1.pcm');
ir1g = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L10.wav1.pcm');
ir1h = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L13.wav1.pcm');
ir1i = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L17.wav1.pcm');
ir1j = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\L18.wav1.pcm');
ir2b = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R4.wav2.pcm');
ir2c = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R5.wav2.pcm');
ir2d = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R6.wav2.pcm');
ir2e = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R13.wav2.pcm');
ir2f = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R8.wav2.pcm');
ir2g = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R12.wav2.pcm');
ir2h = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R13.wav2.pcm');
ir2i = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R14.wav2.pcm');
ir2j = loadpcm('C:\Users\jlo\Desktop\align2\measurements\test6\R15.wav2.pcm');








	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)  
	




	ir1 = [ zeros(1,65536) ir1(:)' ];
	ir1 = [ ir1(:)' zeros(1,65536) ];
	ir1b = [ zeros(1,65536) ir1b(:)' ];
	ir1b = [ ir1b(:)' zeros(1,65536) ];		
	ir1c = [ zeros(1,65536) ir1c(:)' ];
	ir1c = [ ir1c(:)' zeros(1,65536) ];	
	ir1d = [ zeros(1,65536) ir1d(:)' ];		
	ir1d = [ ir1d(:)' zeros(1,65536) ];	
	ir1e = [ zeros(1,65536) ir1e(:)' ];
	ir1e = [ ir1e(:)' zeros(1,65536) ];	
	ir1f = [ zeros(1,65536) ir1f(:)' ];
	ir1f = [ ir1f(:)' zeros(1,65536) ];		
	ir1g = [ zeros(1,65536) ir1g(:)' ];
	ir1g = [ ir1g(:)' zeros(1,65536) ];	
	ir1h = [ zeros(1,65536) ir1h(:)' ];		
	ir1h = [ ir1h(:)' zeros(1,65536) ];	
	ir1i = [ zeros(1,65536) ir1i(:)' ];
	ir1i = [ ir1i(:)' zeros(1,65536) ];		
	ir1j = [ zeros(1,65536) ir1j(:)' ];
	ir1j = [ ir1j(:)' zeros(1,65536) ];		
	
	ir2 = [ zeros(1,65536) ir2(:)' ];
	ir2 = [ ir2(:)' zeros(1,65536) ];	
	ir2b = [ zeros(1,65536) ir2b(:)' ];	
	ir2b = [ ir2b(:)' zeros(1,65536) ];	
	ir2c = [ ir2c(:)' zeros(1,65536) ];
	ir2c = [ zeros(1,65536) ir2c(:)' ];	
	ir2d = [ ir2d(:)' zeros(1,65536) ];	
	ir2d = [ zeros(1,65536) ir2d(:)' ];	
	ir2e = [ zeros(1,65536) ir2e(:)' ];	
	ir2e = [ ir2e(:)' zeros(1,65536) ];	
	ir2f = [ zeros(1,65536) ir2f(:)' ];	
	ir2f = [ ir2f(:)' zeros(1,65536) ];	
	ir2g = [ zeros(1,65536) ir2g(:)' ];
	ir2g = [ ir2g(:)' zeros(1,65536) ];
	ir2h = [ zeros(1,65536) ir2h(:)' ];	
	ir2h = [ ir2h(:)' zeros(1,65536) ];	
	ir2i = [ zeros(1,65536) ir2i(:)' ];	
	ir2i = [ ir2i(:)' zeros(1,65536) ];		
	ir2j = [ zeros(1,65536) ir2j(:)' ];	
	ir2j = [ ir2j(:)' zeros(1,65536) ];		
	
	# Find the impulse center
	[irm1,ic1] = max(abs(hilbert(ir1)));	
	[irm1b,ic1b] = max(abs(hilbert(ir1b)));		
	[irm1c,ic1c] = max(abs(hilbert(ir1c)));		
	[irm1d,ic1d] = max(abs(hilbert(ir1d)));		
	[irm1e,ic1e] = max(abs(hilbert(ir1e)));	
	[irm1f,ic1f] = max(abs(hilbert(ir1f)));		
	[irm1g,ic1g] = max(abs(hilbert(ir1g)));		
	[irm1h,ic1h] = max(abs(hilbert(ir1h)));		
	[irm1i,ic1i] = max(abs(hilbert(ir1i)));	
	[irm1j,ic1j] = max(abs(hilbert(ir1j)));	
	
	[irm2,ic2] = max(abs(hilbert(ir2)));
	[irm2b,ic2b] = max(abs(hilbert(ir2b)));
	[irm2c,ic2c] = max(abs(hilbert(ir2c)));
	[irm2d,ic2d] = max(abs(hilbert(ir2d)));
	[irm2e,ic2e] = max(abs(hilbert(ir2e)));
	[irm2f,ic2f] = max(abs(hilbert(ir2f)));		
	[irm2g,ic2g] = max(abs(hilbert(ir2g)));		
	[irm2h,ic2h] = max(abs(hilbert(ir2h)));		
	[irm2i,ic2i] = max(abs(hilbert(ir2i)));	
	[irm2j,ic2j] = max(abs(hilbert(ir2j)));				
			
			
	# Normalize the impulse responses
	rms1 = norm(ir1);
	ir1 = ir1(:)/rms1;
	rms1b = norm(ir1b);
	ir1b = ir1b(:)/rms1b;	
	rms1c = norm(ir1c);
	ir1c = ir1c(:)/rms1c;	
	rms1d = norm(ir1d);
	ir1d = ir1d(:)/rms1d;	
	rms1e = norm(ir1e);
	ir1e = ir1e(:)/rms1e;	
	rms1f = norm(ir1f);
	ir1f = ir1f(:)/rms1f;	
	rms1g = norm(ir1g);
	ir1g = ir1g(:)/rms1g;	
	rms1h = norm(ir1h);
	ir1h = ir1h(:)/rms1h;	
	rms1i = norm(ir1i);
	ir1i = ir1i(:)/rms1i;		
	rms1j = norm(ir1j);
	ir1j = ir1j(:)/rms1j;	
	
	rms2 = norm(ir2);
	ir2 = ir2(:)/rms2;	
	rms2b = norm(ir2b);
	ir2b = ir2b(:)/rms2b;		
	rms2c = norm(ir2c);
	ir2c = ir2c(:)/rms2c;		
	rms2d = norm(ir2d);
	ir2d = ir2d(:)/rms2d;		
	rms2e = norm(ir2e);
	ir2e = ir2e(:)/rms2e;	
	rms2f = norm(ir2f);
	ir2f = ir2f(:)/rms2f;	
	rms2g = norm(ir2g);
	ir2g = ir2g(:)/rms2g;	
	rms2h = norm(ir2h);
	ir2h = ir2h(:)/rms2h;	
	rms2i = norm(ir2i);
	ir2i = ir2i(:)/rms2i;		
	rms2j = norm(ir2j);
	ir2j = ir2j(:)/rms2j;

	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display	when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
	# Report infos
	disp(sprintf("Frequency : %d,",fs));
	disp(sprintf("IR1 impulse center : %d, max: %f, RMS: %f",ic1, irm1, rms1));
	disp(sprintf("IR1b impulse center : %d, max: %f, RMS: %f",ic1b, irm1b, rms1b));	
	disp(sprintf("IR1c impulse center : %d, max: %f, RMS: %f",ic1c, irm1c, rms1c));
	disp(sprintf("IR1d impulse center : %d, max: %f, RMS: %f",ic1d, irm1d, rms1d));
	disp(sprintf("IR1e impulse center : %d, max: %f, RMS: %f",ic1e, irm1e, rms1e));
	disp(sprintf("IR1f impulse center : %d, max: %f, RMS: %f",ic1f, irm1f, rms1f));	
	disp(sprintf("IR1g impulse center : %d, max: %f, RMS: %f",ic1g, irm1g, rms1g));
	disp(sprintf("IR1h impulse center : %d, max: %f, RMS: %f",ic1h, irm1h, rms1h));
	disp(sprintf("IR1i impulse center : %d, max: %f, RMS: %f",ic1i, irm1i, rms1i));	
	disp(sprintf("IR1j impulse center : %d, max: %f, RMS: %f",ic1j, irm1j, rms1j));	
	
	disp(sprintf("IR2 impulse center : %d, max: %f, RMS: %f",ic2, irm2, rms2));
	disp(sprintf("IR2b impulse center : %d, max: %f, RMS: %f",ic2b, irm2b, rms2b));	
	disp(sprintf("IR2c impulse center : %d, max: %f, RMS: %f",ic2c, irm2c, rms2c));
	disp(sprintf("IR2d impulse center : %d, max: %f, RMS: %f",ic2d, irm2d, rms2d));
	disp(sprintf("IR2e impulse center : %d, max: %f, RMS: %f",ic2e, irm2e, rms2e));
	disp(sprintf("IR2f impulse center : %d, max: %f, RMS: %f",ic2f, irm2f, rms2f));	
	disp(sprintf("IR2g impulse center : %d, max: %f, RMS: %f",ic2g, irm2g, rms2g));
	disp(sprintf("IR2h impulse center : %d, max: %f, RMS: %f",ic2h, irm2h, rms2h));
	disp(sprintf("IR2i impulse center : %d, max: %f, RMS: %f",ic2i, irm2i, rms2i));	
	disp(sprintf("IR2j impulse center : %d, max: %f, RMS: %f",ic2j, irm2j, rms2j));		
	
	fflush(stdout);
	
	##############################################################################	
	# Report the stage
	disp("Mic correction...");
	fflush(stdout);	
	

	disp(mic);
	xp=mic(:,1);
	yp=mic(:,2);
	
	ixl = 20;
	ixu = 20000;
	xf = [ixl:ixu];
	
	mic1 = interp1(xp, yp, xf, "pchip");
	ixg= [1:ixu-ixl];
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,1,1);
	hold("on");
	
	# Plot the magnitude response 1
	subplot(1,1,1);
	semilogx(0.001*(ixg+19), mic1(ixg),["3;" it1 ";"],"LineWidth",DLW);
	#semilogx(0.001 * fs * ixg / 480, mic1(1000*ixg),["3;" it1 ";"],"LineWidth",DLW);
	
	axis([0.02, 20]);
	grid("on");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	title("Microphone response");	
		
	# Save the axis range
	g1ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -20;
	gax(4) = 10;
	
	# Set the uniform axis range
	subplot(1,1,1);	
	axis(gax);
	safetics("y",gax(3):3:gax(4));
	
	# Disable holding the plot and set graph parameters
	subplot(1,1,1);
	hold("off");
		
	# Print to the output file
	print([ outdir fprefix "-mic" fext ],fdevice);	

	
##############################################################################
	# Report the stage
	disp("Various gating times...");
	fflush(stdout);
	
	# Windows array, in ms
	wlst = [100 30 10 3 1];
	
	# Graph resolution
	gres = 16384;
	
	# Graph pregap
	gpgp = 480;
	
	# Scaling base (dB)
	scbs = 14;
	
	# Scaling delta (dB)
	scdt = -6;
	
	# Compute the index limits
	ixl = floor(2 * 20 * gres / fs);
	ixu = ceil(2 * 20000 * gres / fs);
		
	# Open a new plot	
	newplot();
	clf();
	figure(1,"visible","off");	
	
	# Enable holding the plot
	subplot(1,2,1);
	hold("on");
	subplot(1,2,2);
	hold("on");
	
	# Cycle on the windows sizes
	cscl = scbs;
	cg = 1;
	for cws = wlst
		# Computes the number of samples for the current window
		wns = round(fs * cws / (2 * 1000));
		
		# Creates the response prewindow
		wind = [ones(1,gpgp) ones(1,wns) (blackman(2 * wns)((wns + 1):(2 * wns)))' zeros(1,gres - (gpgp + 2 * wns))]';
		
		# Extract the windowed impulse responses
		ir1w = ir1([(ic1 - gpgp):(ic1 + (gres - (gpgp + 1)))]) .* wind;
		ir1wb = ir1b([(ic1b - gpgp):(ic1b + (gres - (gpgp + 1)))]) .* wind;		
		ir1wc = ir1c([(ic1c - gpgp):(ic1c + (gres - (gpgp + 1)))]) .* wind;		
		ir1wd = ir1d([(ic1d - gpgp):(ic1d + (gres - (gpgp + 1)))]) .* wind;		
		ir1we = ir1e([(ic1e - gpgp):(ic1e + (gres - (gpgp + 1)))]) .* wind;
		ir1wf = ir1f([(ic1f - gpgp):(ic1f + (gres - (gpgp + 1)))]) .* wind;
		ir1wg = ir1g([(ic1g - gpgp):(ic1g + (gres - (gpgp + 1)))]) .* wind;		
		ir1wh = ir1h([(ic1h - gpgp):(ic1h + (gres - (gpgp + 1)))]) .* wind;		
		ir1wi = ir1i([(ic1i - gpgp):(ic1i + (gres - (gpgp + 1)))]) .* wind;		
		ir1wj = ir1j([(ic1j - gpgp):(ic1j + (gres - (gpgp + 1)))]) .* wind;

		
		ir2w = ir2([(ic2 - gpgp):(ic2 + (gres - (gpgp + 1)))]) .* wind;
		ir2wb = ir2b([(ic2b - gpgp):(ic2b + (gres - (gpgp + 1)))]) .* wind;
		ir2wc = ir2c([(ic2c - gpgp):(ic2c + (gres - (gpgp + 1)))]) .* wind;
		ir2wd = ir2d([(ic2d - gpgp):(ic2d + (gres - (gpgp + 1)))]) .* wind;
		ir2we = ir2e([(ic2e - gpgp):(ic2e + (gres - (gpgp + 1)))]) .* wind;
		ir2wf = ir2f([(ic2f - gpgp):(ic2f + (gres - (gpgp + 1)))]) .* wind;
		ir2wg = ir2g([(ic2g - gpgp):(ic2g + (gres - (gpgp + 1)))]) .* wind;		
		ir2wh = ir2h([(ic2h - gpgp):(ic2h + (gres - (gpgp + 1)))]) .* wind;		
		ir2wi = ir2i([(ic2i - gpgp):(ic2i + (gres - (gpgp + 1)))]) .* wind;		
		ir2wj = ir2j([(ic2j - gpgp):(ic2j + (gres - (gpgp + 1)))]) .* wind;
		
				
		# Computes the smoothed magnitude response
		ir1m = ssev(ir1w,fs,0.15,1);
		ir1mb = ssev(ir1wb,fs,0.15,1);		
		ir1mc = ssev(ir1wc,fs,0.15,1);		
		ir1md = ssev(ir1wd,fs,0.15,1);		
		ir1me = ssev(ir1we,fs,0.15,1);	
		ir1mf = ssev(ir1wf,fs,0.15,1);
		ir1mg = ssev(ir1wg,fs,0.15,1);		
		ir1mh = ssev(ir1wh,fs,0.15,1);		
		ir1mi = ssev(ir1wi,fs,0.15,1);		
		ir1mj = ssev(ir1wj,fs,0.15,1);
		
		ir2m = ssev(ir2w,fs,0.15,1);		
		ir2mb = ssev(ir2wb,fs,0.15,1);
		ir2mc = ssev(ir2wc,fs,0.15,1);		
		ir2md = ssev(ir2wd,fs,0.15,1);		
		ir2me = ssev(ir2we,fs,0.15,1);	
		ir2mf = ssev(ir2wf,fs,0.15,1);
		ir2mg = ssev(ir2wg,fs,0.15,1);		
		ir2mh = ssev(ir2wh,fs,0.15,1);		
		ir2mi = ssev(ir2wi,fs,0.15,1);		
		ir2mj = ssev(ir2wj,fs,0.15,1);

		
		% # Computes the graph lower bounds
		glb = fs / (0.7 * wns);
		glb = round(glb / (fs / (2 * gres)));
		glb = max(glb,2);
		
		# Computes the graph index
		ixg = max(ixl,glb):ixu;
    
    				
		# Plot the magnitude response
		subplot(1,2,1);
		#semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + (20 * (log10(ir1m(1 + ixg))+log10(ir1mb(1 + ixg))+log10(ir1mc(1 + ixg))+log10(ir1md(1 + ixg))+log10(ir1me(1 + ixg))+log10(ir1mf(1 + ixg))+log10(ir1mg(1 + ixg))+log10(ir1mh(1 + ixg))+log10(ir1mi(1 + ixg))+log10(ir1mj(1 + ixg)))/10),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + (20 * (log10(ir1m(1 + ixg)))),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		
		subplot(1,2,2);
		#semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + (20 * (log10(ir2m(1 + ixg))+log10(ir2mb(1 + ixg))+log10(ir2mc(1 + ixg))+log10(ir2md(1 + ixg))+log10(ir2me(1 + ixg))+log10(ir2mf(1 + ixg))+log10(ir2mg(1 + ixg))+log10(ir2mh(1 + ixg))+log10(ir2mi(1 + ixg))+log10(ir2mj(1 + ixg)))/10),"color",hsv2rgb([0, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);
		semilogx(0.001 * 0.5 * fs * ixg / gres,cscl + (20 * (log10(irzc(1 + ixg)))),"color",hsv2rgb([2/3, 1, 0.5 + 0.5 * cg / length(wlst)]),"LineWidth",DLW);    

		# Adjust the scaling
		cscl = cscl + scdt;
		cg = cg + 1;
	endfor	
	
	subplot(1,2,1);
	hold("off");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(["Mean frequency response, 1-3-10-30-100 ms gatings  " it1 ]);

	subplot(1,2,2);
	hold("off");
	safetics("x",[0.02,0.05,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,6,8,10,15,20]);
	xlabel("Frequency (kHz)");
	grid("on");
	legend(3);
	title(it2);	
	
	# Save the axis range
	subplot(1,2,1);
	axis([0.02, 20]);	
	g1ax = axis();
	subplot(1,2,2);
	axis([0.02, 20]);	
	g2ax = axis();

	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = -20;
	gax(4) = 40;
	
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	subplot(1,2,2);	
	axis(gax);
	safetics("y",gax(3):6:gax(4));
	
	# Print to the output file
	print([ outdir fprefix "-Multiple-Various-gatings" fext ],fdevice);

	# Remove variables no longer used
	clear wind ir1w ir1m ir2w ir2m ixl ixu ixg g1ax g2ax gax;
	
	
	

	
	
	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);

endfunction