## This function is part of Localisation.exe, by Jean-Luc Ohl
#
# factordelay = reserved for future use
# factorampl = dB for one  of perceived source move




cd D:\documents\audio\align2\files\octave\;
wavfileL1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\1L.wav';
wavfilenameL1 = "1L.wav";
wavfilepathL1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\';
wavfileR1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\1R.wav';
wavfilenameR1 = "1R.wav";
wavfilepathR1 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\';
wavfileL2 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\4Lb.wav';
wavfilenameL2 = "4Lb.wav";
wavfilepathL2 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\';
wavfileR2 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\4Rb.wav';
wavfilenameR2 = "4Rb.wav";
wavfilepathR2 = 'D:\documents\audio\roomEQ\mesures-sur-sites\igor130321\presets\';



fdevice = '-S1200,220';
factordelay = 0.02;
factorampl = 0.3;
 
 
##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 2;
	
	# Colormap
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	
##############################################################################	
	# Report the stage
	disp("Localisation...");
	fflush(stdout);
	
	[wavL1,fs,bps] = wavread([wavfileL1]);
	wavL1 = [zeros(16384,1); wavL1(:); zeros(65536,1)];	
	[wavR1,fs,bps] = wavread([wavfileR1]);
	wavR1 = [zeros(16384,1); wavR1(:); zeros(65536,1)];
	[wavL2,fs,bps] = wavread([wavfileL2]);
	wavL2 = [zeros(16384,1); wavL2(:); zeros(65536,1)];		
	[wavR2,fs,bps] = wavread([wavfileR2]);	
	wavR2 = [zeros(16384,1); wavR2(:); zeros(65536,1)];	

	[irmL1,icL1] = max(abs(wavL1));	
	[irmL2,icL2] = max(abs(wavL2));	
	
	# Extract the windowed impulse responses, keep time differences
	irwvL1 = wavL1([icL1-4096:icL1+64735]);
	irwvR1 = wavR1([icL1-4096:icL1+64735]);
	irwvL2 = wavL2([icL2-4096:icL2+64735]);
	irwvR2 = wavR2([icL2-4096:icL2+64735]);	

	# Performs the frequency dependant windowing
	irwL1 = irslprefilt(irwvL1,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwR1 = irslprefilt(irwvR1,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwL2 = irslprefilt(irwvL2,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwR2 = irslprefilt(irwvR2,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);

################################## 
	
	# 33 Center frequencies
	cf = [16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000 25000];
	# Computes the 32 frequency bounds
	fb = (cf(1:(end-1)) .* cf(2:(end))) .^ 0.5;
	# Remove the unused center frequencies
	cf = cf(2:(end-1));
	
	for cb = 1:30 
		# Computes the current filter
		bf = bandpassfir(16384,2 * cf(cb) / fs,2 * cf(cb + 1) / fs) .* chebwin(16384,60)';
			
		# Computes the band ir
		birfL1 = fftconv(bf,irwL1);
		birfR1 = fftconv(bf,irwR1);
		birfL2 = fftconv(bf,irwL2);
		birfR2 = fftconv(bf,irwR2);	
	
		birs1 = round(((20*log10(rms(birfL1))) - 20*log10(rms(birfR1)))/(0.015*factorampl*0.04/factordelay));
		birs2 = round(((20*log10(rms(birfL2))) - 20*log10(rms(birfR2)))/(0.015*factorampl*0.04/factordelay));
				
		birx1(cb,:) = xcorr(abs(birfL1), abs(birfR1),'coeff');	
		birsh1(cb,:) = shift(birx1(cb,:), birs1);				
		birx2(cb,:) = xcorr(abs(birfL2), abs(birfR2),'coeff');			
		birsh2(cb,:) = shift(birx2(cb,:), birs2);	
	endfor

	birt1	= transpose(birsh1);
	birt2	= transpose(birsh2);
	for n= 1:30
		birr1(:,n) = resample(birt1(:,n),1,16);
		birm1(:,n) = birr1(:,n)./max(birr1(:,n));
		birr2(:,n) = resample(birt2(:,n),1,16);
		birm2(:,n) = birr2(:,n)./max(birr2(:,n));
	endfor

#############################################################################	
	# Report the stage
	disp("Plot...");
	fflush(stdout);
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");	
	
	subplot(1,2,1);
	hold("on");
	imagesc(birm1,[0.5, 1]); 
	grid("on");		
	set(gca(),"ydir","normal");
	#centerline = 1450
	axis([9, 28, (1450-150*(factordelay/0.04)), 1450+(150*(factordelay/0.04))], "label[x]");
	safetics("y",(1450-150*(factordelay/0.04)):(50*(factordelay/0.04)):1450+(150*(factordelay/0.04)));
	set(gca, 'xticklabel','200|600|2k|6k','yticklabel','R 30|20|10|0|10|20|L 30');
	colormap(EDCMap);		
	title([wavfilenameL1 "-" wavfilenameR1 ]);
	hold("off");	
	
	subplot(1,2,2);
	hold("on");
	imagesc(birm2,[0.5, 1]); 
	grid("on");		
	set(gca(),"ydir","normal");
	axis([9, 28, (1450-150*(factordelay/0.04)), 1450+(150*(factordelay/0.04))], "label[x]");
	safetics("y",(1450-150*(factordelay/0.04)):(50*(factordelay/0.04)):1450+(150*(factordelay/0.04)));
	set(gca, 'xticklabel','200|600|2k|6k','yticklabel','R 30|20|10|0|10|20|L 30');
	colormap(EDCMap);		
	title([wavfilenameL2 "-" wavfilenameR2 ]);
	hold("off");
	
	# Print to the output file
	print([wavfilepathL1 wavfilenameL1 wavfilenameL2 fext ],fdevice);

	# Report
	disp("Completed.");
	fflush(stdout);
	