## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of DRC - Digital room correction

##
## usage: [ cf, fb ] = oct3bands()
##
## Returns the center frequency and the frequency
## bounds for standard 1/3 of octave bands
##

function [ cf, fb ] = oct12bands()
	# Assign the center frequencies
	# extended by one band
	cf = [20 22 24 26 28 30 32 34 36 38 40 43 46 49 52 55 58 61 65 69 72 76 80 84 88 93 97 101 105 110 120 125 130 135 140 145 150 155 160 165 170 175 180 185 190 195 200 210 220 230 240 250 260 282 315 357 400 450 500 565 630 705 800 900 1000 1125 1250 1425 1600 1800 2000 2250 2500 2775 3150 3575 4000 4500 5000 5650 6300 7150 8000 9000 10000 11250 12500 14250 16000 18000 20000];
	
	# Computes the frequency bounds
	fb = (cf(1:(end-1)) .* cf(2:(end))) .^ 0.5;
	
	# Remove the unused center frequencies
	cf = cf(2:(end-1));
endfunction