## Copyright (C) 2005 Denis Sbragion
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
##(at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## This function is part of DRC - Digital room correction

##
## usage: [ cf, fb ] = octbands()
##
## Returns the center frequency and the frequency
## bounds for octave bands
##

function [ cf, fb ] = octbands()
	# Assign the center frequencies
	# extended by one band
	cf = [32 63 125 250 500 1000 2000 4000 8000 16000];
	
	# Computes the frequency bounds
	fb = (cf(1:(end-1)) .* cf(2:(end))) .^ 0.5;
	
	# Remove the unused center frequencies
	cf = cf(2:(end-1));
endfunction