## This function is part of Align2, by Jean-Luc Ohl
 
 
 
fs =48000;
fdevice = '-S1200,220';
show = 'D:\documents\audio\align2\measurements\igor-sub2b\opendrc\igor-sub2b-SPMO-L-norm.wav';
name = 'igor-sub2b-SPMO-L-norm.wav';
fpath = 'D:\documents\audio\align2\measurements\igor-sub2b\opendrc\';
cd D:\documents\audio\align2\files\octave\;
 
 


##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;

##############################################################################	
	
	[wav1,fs,bps] = wavread([show]);	
	wavss1 = 20*log10(ssev(wav1,fs,0.1,1));

	wav1 = [ zeros(1,65536) wav1(:)' ];
	wav1 = [ wav1(:)' zeros(1,65536) ];	
 	[irm,ic1] = max(abs(wav1));
	
	# Resampling
	rf = 40;
	rfl = 16383;
	rcf = 0.95;
	rat = 160;
	irp = fs/200;
	ira = 2*fs/200;
	
	# Creates the oversampled impulse responses
	ir1os = rf * iupsample(wav1([ic1-irp:ic1+ira]),rf,rfl,rcf,rat);
	
	##############################################################################		
	# Report the stage
	disp("Time response, full range...");
	fflush(stdout);

	# normalize impulse response
	ir1os = ir1os/max(abs(ir1os));

	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");
	
	# Plot the oversampled impulse responses 1
	subplot(1,2,1);
	plot(1000 * ((([0:length(ir1os)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),ir1os, "LineWidth",DLW);
	axis([-1, 5]);
	grid("on");
	title(name);
	
	# Computes the uniform axis range
	gax = axis();
	gax(1) = -1;
	gax(2) = 5;
	gax(3) = -1;
	gax(4) = 1;
	
	# Set the uniform axis range
	subplot(1,2,1);	
	axis(gax);
	safetics("x",gax(1):1:gax(2));
	safetics("y",gax(3):0.5:gax(4));
		
	# Plot 2
	subplot(1,2,2);
	ixg= [1:columns(wavss1)];
	semilogx(ixg*fs/(2000*columns(wavss1)),wavss1, "LineWidth",DLW);
	
	grid("on");
	axis([0.02, 20, -21, 21]);
	safetics("x",[0.02,0.03,0.05,0.07,0.1,0.2,0.3,0.5,0.7,1,1.5,2,3,4,5,7,10,13,16,20]);
	safetics("y",-21:3:21);
	title("Frequency response");
		
	# Print to the output file
	print([fpath name fext],fdevice);

	# Report the stage
	disp("Completed");
	fflush(stdout);
	