## This function is part of wavalyze, by Jean-Luc Ohl
## usage: wavalyze(wavfile,wavefilename,wavefilepath,fext,fdevice)
## wavfile = wavfile to analyze
## wavefilename = name of graph
## wavefilepath= output directory for graph files
## fext = extension for graph files, default '.png'
## fdevice = print device for graph files, default '-depsc'

cd D:\documents\audio\align2\files\octave\;
wavfile1 = 'D:\documents\audio\sons\PinkNoise\pink-20dBFSrms.wav';
wavfilename1 = "pink-20dBFSrms.wav";
wavfilepath1 = 'D:\documents\audio\sons\PinkNoise\';

wavfile2 = 'D:\documents\audio\sons\PinkNoise\Digido_Pink_min_20_dBFS_RMS_uncor_st_441.WAV';
wavfilename2 = "Digido_Pink_min_20_dBFS_RMS_uncor_st_441.WAV";
wavfilepath2 = 'D:\documents\audio\sons\PinkNoise\';

wavfile3 = 'D:\documents\audio\sons\PinkNoise\REF DOLBY 85SPL (6).A1.wav';
wavfilename3 = "REF DOLBY 85SPL (6).A1.wav";
wavfilepath3 = 'D:\documents\audio\sons\PinkNoise\';

wavfile4 = 'D:\documents\audio\sons\PinkNoise\MeyerSound\Dolby -20dbfsDMU Pink Noise.wav';
wavfilename4 = "Dolby -20dbfsDMU Pink Noise.wav";
wavfilepath4 = 'D:\documents\audio\sons\PinkNoise\MeyerSound\';

fext = ".png";
fdevice = '-S1200,220';
fullscale = 0;
pink = 1;

D = [0.049922035 -0.095993537 0.050612699 -0.004408786];
C = [1 -2.494956002   2.017265875  -0.522189400];

##############################################################################	
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	# Report the stage
	disp("Analysis...");
	fflush(stdout);	

	#corr = fullscale;
	corr = 0;	
	hbw = (2 ^ (0.3/ 2));	

##############################################################################	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,1,1);
	hold("on");

	# Plot 1
	subplot(1,1,1);
	
	[wav1,fs1,bps1] = wavread([wavfile1]);
	wav1L = wav1(:, 1);	
		n = length(wav1L);
		bl = 1 + round((0:(n - 1)) / hbw);
		bu = 2 + round((0:(n - 1)) * hbw);
		bu = min(n + 1,bu);
	[B,A] = adsgn(fs1);
    wav1Lf = filter(B,A,wav1L);	
	#avg1L = real(20 * log10(sum(wav1Lf)/length(wav1Lf)))+corr;		
	rms1L = 20 * log10(rms(wav1Lf))+corr;		
	[irm1L,ic1L] = max(abs(wav1Lf));	
	irm1L = 20 * log10(irm1L)+corr;
	cf1L = irm1L-rms1L;	
	if (pink == 1)	
	wav1Lf = filter(C,D,wav1L); 	
	else
	endif
	sev = abs(fft(postpad(wav1Lf(:)',2 * n))(1:n));
	sev = cumsum([0 sev]);
	sev = (sev(bu) - sev(bl)) ./ (bu - bl);
	wav1Lf = 20*log10(sev);	
	
	ixg= [1:columns(wav1Lf)];
	semilogx(ixg*fs1/(2000*columns(wav1Lf)), wav1Lf, ["3;" " maxA " num2str(irm1L,3) " rmsA " num2str(rms1L,3) " crestf " num2str(cf1L,3) ";"],"LineWidth",DLW);
	# Remove variables no longer used
	clear wav1 wav1Lf irm1L rms1L cf1L sev;	

	[wav2,fs2,bps2] = wavread([wavfile2]);	
	wav2L = wav2(:, 1);	
		n = length(wav2L);
		bl = 1 + round((0:(n - 1)) / hbw);
		bu = 2 + round((0:(n - 1)) * hbw);
		bu = min(n + 1,bu);
	[B,A] = adsgn(fs2);
    wav2Lf = filter(B,A,wav2L);			
	#avg2L = real(20 * log10(sum(wav2Lf)/length(wav2Lf)))+corr;		
	rms2L = 20 * log10(rms(wav2Lf))+corr;		
	[irm2L,ic2L] = max(abs(wav2Lf));	
	irm2L = 20 * log10(irm2L)+corr;
	cf2L = irm2L-rms2L;	
	if (pink == 1)	
	wav2Lf = filter(C,D,wav2L); 	
	else
	wav2Lf = wav2Lf; 		
	endif		
	sev = abs(fft(postpad(wav2Lf(:)',2 * n))(1:n));
	sev = cumsum([0 sev]);
	sev = (sev(bu) - sev(bl)) ./ (bu - bl);
	wav2Lf = 20*log10(sev);
	
	ixg= [1:columns(wav2Lf)];
	semilogx(ixg*fs2/(2000*columns(wav2Lf)), wav2Lf, ["1;" " maxA " num2str(irm2L,3) " rmsA " num2str(rms2L,3) " crestf " num2str(cf2L,3) ";"],"LineWidth",DLW);
	# Remove variables no longer used
	clear wav2 wav2Lf irm2L rms2L cf2L sev;	
	
	[wav3,fs3,bps3] = wavread([wavfile3]);	
	wav3L = wav3(:, 1);
		n = length(wav3L);
		bl = 1 + round((0:(n - 1)) / hbw);
		bu = 2 + round((0:(n - 1)) * hbw);
		bu = min(n + 1,bu);
	[B,A] = adsgn(fs3);
    wav3Lf = filter(B,A,wav3L);		
	#avg3L = real(20 * log10(sum(wav3Lf)/length(wav3Lf)))+corr;		
	rms3L = 20 * log10(rms(wav3Lf))+corr;		
	[irm3L,ic3L] = max(abs(wav3Lf));	
	irm3L = 20 * log10(irm3L)+corr;
	cf3L = irm3L-rms3L;	
	if (pink == 1)	
	wav3Lf = filter(C,D,wav3L); 	
	else
	wav3Lf = wav3Lf; 		
	endif		
	sev = abs(fft(postpad(wav3Lf(:)',2 * n))(1:n));
	sev = cumsum([0 sev]);
	sev = (sev(bu) - sev(bl)) ./ (bu - bl);
	wav3Lf = 20*log10(sev);	
	
	ixg= [1:columns(wav3Lf)];
	semilogx(ixg*fs1/(2000*columns(wav3Lf)), wav3Lf, ["2;" " maxA " num2str(irm3L,3) " rmsA " num2str(rms3L,3) " crestf " num2str(cf3L,3) ";"],"LineWidth",DLW);
	# Remove variables no longer used
	clear wav3 wav3Lf irm3L rms3L cf3L sev;	
	
	[wav4,fs4,bps4] = wavread([wavfile4]);	
	wav4L = wav4(:, 1);
		n = length(wav4L);
		bl = 1 + round((0:(n - 1)) / hbw);
		bu = 2 + round((0:(n - 1)) * hbw);
		bu = min(n + 1,bu);
	[B,A] = adsgn(fs4);
    wav4Lf = filter(B,A,wav4L);		
	#avg4L = real(20 * log10(sum(wav4Lf)/length(wav4Lf)))+corr;		
	rms4L = 20 * log10(rms(wav4Lf))+corr;		
	[irm4L,ic4L] = max(abs(wav4Lf));	
	irm4L = 20 * log10(irm4L)+corr;
	cf4L = irm4L-rms4L;	
	if (pink == 1)	
	wav4Lf = filter(C,D,wav4L); 	
	else
	wav4Lf = wav4Lf; 		
	endif		
	sev = abs(fft(postpad(wav4Lf(:)',2 * n))(1:n));
	sev = cumsum([0 sev]);
	sev = (sev(bu) - sev(bl)) ./ (bu - bl);
	wav4Lf = 20*log10(sev);

	ixg= [1:columns(wav4Lf)];
	semilogx(ixg*fs2/(2000*columns(wav4Lf)), wav4Lf, ["4;" " maxA " num2str(irm4L,3) " rmsA " num2str(rms4L,3) " crestf " num2str(cf4L,3) ";"],"LineWidth",DLW);
	# Remove variables no longer used
	clear wav4 wav4Lf irm4L rms4L cf4L sev;	
	
	grid("on");
	axis([0.01, 22, 40, 80]);
	safetics("x",[0.02,0.04,0.07,0.1,0.2,0.4,0.7,1,2,4,7,10,15,20]);
	safetics("y",40:10:80);
	title("Spectrum");

	# Disable holding the plot and set graph parameters
	subplot(1,1,1);
	hold("off");

	# Print to the output file
	print([wavfilepath1 wavfilename1 fext ],fdevice);

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);
	